#if 0 /*
#  This is a C/MPW script hybrid!
# Just execute this on the MPW command line, as is - Really!

Unset 1;(Evaluate "{0}"=~/()1./)dev:null; Set Targ "`Quote "{1}"`"

If "{1}"=="-r"; Rez "{1}.r"; Exit 0; End ## Rez.out
Set COptions68K "-mc68040 -b2 -sym off -proto strict -opt speed -load "{CHeaders}"Headers68K"
## changed "-speed,unswitch" to "-inline 1 -opt size" for faster compilation time; 2008.05.30 13:33 GMT, 13:58 GMT
Set COptionsPPC "-sym off -proto strict -inline 1 -opt size,warn_maybe_uninit -load "{CHeaders}"HeadersPPC"
If "`Exists "{0}".DisAsmExt.o`"==""
  SC "{0}" -o "{0}".DisAsmExt.o -d DISASM_EXTENSIONS {COptions68K}
End
If "{1}"=="-fat"
  If "`Exists "{0}".DisAsmExt.x`"=="" 
    MrC "{0}" -o "{0}".DisAsmExt.x -d DISASM_EXTENSIONS {COptionsPPC}
  End
  MrC "{0}" -o "{0}".x {COptionsPPC}
End

If "{1}"!="-ppc"; SC "{0}" -o "{0}".o {COptions68K}; End
Delete -i {Targ}
If "{1}"=="-fat"
  PPCLink -o {Targ} "{0}".x "{0}".DisAsmExt.x "{SharedLibraries}"StdCLib_3.7 
    "{PPCLibraries}"StdCRuntime.o "{PPCLibraries}"PPCCRuntime.o 
    "{SharedLibraries}"InterfaceLib "{PPCLibraries}"PPCToolLibs.o 
    "{SharedLibraries}"MathLib
End
If "{1}"!="-ppc"
  ILink -o {Targ} -t 'MPST' -c 'MPS ' -compact -pad 0 -state nouse -br 020 
    "{0}".o "{0}".DisAsmExt.o "{Libraries}"MacRuntime.o "{CLibraries}"StdCLib.o 
    "{Libraries}"Interface.o "{Libraries}"IntEnv.o "{Libraries}"ToolLibs.o 
    "{Libraries}"MathLib.o -sn %A5Init=Main -sn crc=Lib -sn INTENV=Lib -sn SADEV=Lib 
    -sn STDCLIB=Lib -sn STDIO=Lib -sn SANELIB=Lib -sn CSANELib=Lib 
    -sn dis68k=Disassembler
End
Delete -i "{0}".o "{0}".x
Rez -a -o {Targ} "{1}.r"
Echo "#include "MacTypes.r"n
  resource 'vers' (1) {n
    0x01, 0x24, alpha, 1, verUS, "1.2.4a1",n
    "v1.2.4a1 by Adam P., July 2008"};n" |Rez -a -o {Targ}
Exit 0
# */
#endif

/* ---- constants */

#define INT_UNDEF							(-0x80000000L) /* would be LONG_MIN... */

#define DEFAULT_CODETYPE					FOUR_CHAR_CODE('CODE')

/* operand selector type masks */
#define _op_XX								0
#define _op_XX_B							1
#define _op_XX_W							2
#define _op_XX_L							3

/*#define _rTrS_selector_mask 3*/

#include <DisAsmLookup.h>

#include <stdlib.h> /* only for realloc */

/* ---- extension prototypes */

extern int make_atrap_strings(const Ptr p, const Ptr p2, UInt16 t, UInt8 *a, UInt8 *b, UInt8 *c);
extern Ptr scan_to_next_module(Ptr s, const Ptr e, void **next, UInt8 *next_name, Boolean near);

extern int make_base_string(void *str, const char *basechars, unsigned value, unsigned base, int minlength);
extern void lower_operands(UInt8 *str, int length);

extern UInt32 calculate_crc32(void *data, long count, UInt32 crc);
extern long int read_any_integer(const char *str);
extern OSType read_code_type(const char *str);

extern long get_disasm_extensions_version(void); /* 0x10000 == 1.0 */
int get_disasm_selector_trap_count(void);

#ifdef DISASM_EXTENSIONS
/*
 reveng.c w/ DISASM_EXTENSIONS (originally TRAPWORD_EXTENSIONS, ATrapExt.o)
  useless little optimizations... a land of typos that manufacture freezes...

  Revised: 2008.07.07 10:23 GMT
*/

long int read_any_integer(const char *str)
{
	UInt8			*s, c;

	unsigned long int	r = 0, m = 0;

	if ((s=(UInt8*)str)==NULL || (c=*s++)==0)
		return INT_UNDEF;
	if ((c+=-'-')==0)
	{
		m = -1;
		if ((c=*s++)==0)
			return INT_UNDEF;
	} else if ((c+='-'-'+')==0)
	{
		if ((c=*s++)==0)
			return INT_UNDEF;
	} else if ((UInt8)((c+='+')-'0')>(UInt8)('9'-'0'))
		return INT_UNDEF;
	if (c=='0')
	{
		if ((c=*s++)==0)
			return 0;
		if (c!='x' && c!='X')
		{ /* octal */
			do
			{
				if ((c+=-'0')>7)
					if (c<=(UInt8)('9'-'0') || (c+='0'-'A')<=(UInt8)('Z'-'A')
							|| (c+='A'-'a')<=(UInt8)('z'-'a') || (c+='a'-'_')==0)
						return INT_UNDEF;
					else
						break;
				r = r*8+c;
			} while((c=*s++)!=0);
		} else
		{ /* hexadecimal */
			if ((c=*s++)==0)
				return INT_UNDEF;
			do
			{
				if ((c+=-'0')<=(UInt8)('9'-'0'))
					r = r*16+c;
				else if ((c+='0'-'A')<=(UInt8)('Z'-'A') || (c+='A'-'a')<=(UInt8)('z'-'a'))
					if (c>(UInt8)('F'-'A'))
						return INT_UNDEF;
					else
						r = r*16+c+10;
				else if ((c+='a'-'_')==0)
					return INT_UNDEF;
				else
					break;
			} while((c=*s++)!=0);
		}
	} else
	{ /* decimal */
		do
		{
			c += -'0';
			if (c>(UInt8)('9'-'0'))
				if ((c+='0'-'A')<=(UInt8)('Z'-'A') || (c+='A'-'a')<=(UInt8)('z'-'a')
						|| (c+='a'-'_')==0)
					return INT_UNDEF;
				else
					break;
			r = r*10+c;
		} while((c=*s++)!=0);
	}

	return r=(r^m)-m;
}

OSType read_code_type(const char *str)
{
	UInt8			t[12+sizeof(OSType)], *d = t, *s, c, x = 10;

	if ((s=(UInt8*)str)==NULL || (c=*s++)==0)
		return DEFAULT_CODETYPE;
	*(OSType*)t = '    ';

	do
	{
		*d++ = c;
		if (--x==0)
		{ /* filled entire 10-char buffer; try for hex type */
			s = t, d = 12+t, x = 4;
			if (*s++!='0' || (*s!='x' && *s!='X'))
				break;
			++s;
			do
			{
				if ((c=-'0'+*s++)<=9)
					*d = c<<4;
				else if ((c+=('0'-'A'))<=('Z'-'A')) /*((c+=('0'-'A'+10))<=('Z'-'A'+10))*/
					*d = c+10<<4;
				else if ((c+=('A'-'a'))<=('z'-'a'))
					*d = c+10<<4;
				else
					goto end;
				if ((c=-'0'+*s++)<=9)
					*d++ |= c;
				else if ((c+=('0'-'A'))<=('Z'-'A'))
					*d++ |= c+10;
				else if ((c+=('A'-'a'))<=('z'-'a'))
					*d++ |= c+10;
				else
					goto end;
			} while(--x);
			*(OSType*)t = *(OSType*)(12+t);
			break;
		}
	} while((c=*s++)!=0);
end:
	return *(OSType*)t;
}

/* added 2007.12.10 15:24 GMT */
/* returns string length */
int make_base_string(void *out_string,
	const char *basechars,
	unsigned value,
	unsigned base,
	int minlength)
{
	UInt8			store[32];
	UInt8			*s = 32+store, *d = (UInt8*)out_string;
	int				x = 0;

	if (out_string==NULL)
		return 0;
	if (minlength<=0)
		minlength = 1;
	else if (minlength>32)
		minlength = 32;

	/* write to stack array */
	do
	{
		unsigned	i = value;

		*--s = basechars[i-(value/=base)*base];
	} while(++x<minlength || value!=0);
	minlength = x;

	/* copy to output (without memcpy) */
	if (x&1)
		*d++ = *s++;
	if (x&2)
		*((UInt16*)d)++ = *((UInt16*)s)++;
	if (x&4)
		*((UInt32*)d)++ = *((UInt32*)s)++;
	if ((x&=-8)!=0)
		do{*((UInt32*)d)++ = *((UInt32*)s)++; *((UInt32*)d)++ = *((UInt32*)s)++;}while((x+=-8)!=0);

	return minlength;
}

#if __SC__ && !defined(__powerc)
# pragma segment dis68k /* crampd */
#endif

long get_disasm_extensions_version()
{
	return 0x13000|TARGET_CPU_PPC;
}

int get_disasm_selector_trap_count()
{
	return Count1Resources('rTrS');
}

static Ptr test_other_module_names(UInt8 *s, void *e, UInt8 *d)
{
	Ptr				next_module;
	UInt8			old_v;

	/* yes, a destructive measure */
	if (((old_v=s[2])!=0 && (old_v&0x7F)!=s[3])
			|| s[3]==0 || s[4]==0x60 || s[5]==0) /* further verify validity; 2008.04.18 22:36 GMT */
		return NULL;

	s[2] = 0x80;
	/* why didnt the code writers fix the StringPtr result type? */
	if ((next_module=(Ptr)validMacsBugSymbol(2+(Ptr)s,(Ptr)e,d))!=NULL
			&& d[0]<252)
		*(UInt32*)(-2+(d[0]+=3)+d) = '(?)\0';
	s[2] = old_v;

	return next_module;
}

/* added; 2007.12.15 01:31 GMT */
static int get_instruction_size(Ptr s, Ptr e)
{
	UInt8			buf[128]; /* unused */
	int				size;
	short			bytes_used;

	/*if ((c+=0x62-0xF2)==0 || (c+=0xF2-0xF6)==0) // Fxxxxx|MOVE16
		return 4;*/
	Disassembler(0,&bytes_used,s,buf,buf,buf,NULL);
	if (bytes_used<=0)
		return 2;
	else if ((size=e-s)>bytes_used)
		size = bytes_used;

	return size;
}

/* revised: 2007.12.20 05:28 GMT */
Ptr scan_to_next_module(Ptr instruction, /* first instruction to code */
	const Ptr code_end, /* end pointer to code */
	void **next, /* pointer next (probable) module */
	UInt8 *next_name, /* name of closest module */
	Boolean near) /* terminate at first RTx|JMP (A0) within modules branches */
{
	UInt8			*p = NULL, *b = NULL, *s, *e, *t = NULL, c;
	UInt8			*nb = near ? NULL:(UInt8*)-1; /* near feature added; 2007.12.16 00:21 GMT */

	if ((s=(UInt8*)instruction)==NULL || instruction>code_end)
		return NULL;
	/* not recommended going over 64KB */
	if ((UInt8*)code_end<(e=65536+s))
		e = (UInt8*)code_end;
	do
	{
		c = *s++;
		if ((c+=-0x4E)==0)
		{
			if ((c=*s)==0)
				continue;
			else if ((c+=-0x74)==0 /* RTS */
					|| (c+=0x74-0x75)==0 /* RTD */
					|| (c+=0x75-0xD0)==0) /* JMP (A0) */
			{
				Ptr			a;

				p = -1+s;
				endOfModule((Ptr)p,code_end,next_name,next);
				/* notice (and exclude) quadruple RTS */
				/*if (memcmp(next_name,"\008NuNuNuNu",9)==0)*/
				if (next_name[0]==8 && *(UInt32*)(1+next_name)=='NuNu' && *(UInt32*)(5+next_name)=='NuNu')
					continue;
				if (next_name[0]!=0)
				{
					*next = (Ptr)(~1&(long int)*next);
					return (Ptr)(~1&(long int)p);
				} else if ((a=test_other_module_names(-1+s,code_end,next_name))!=NULL)
					{*next = a; return -1+(Ptr)s;}
				else if (*s==0x74)
					s += 2; /* skip literal */
				if (s>nb)
					return NULL;
				continue;
			/*} else if (((c+=0xD0-0x50)&~7)==0) // LINK.W Ax,#xxxx */
			} else if ((c+=0xD0-0x56)==0) // LINK A6,#xxxx */
			{
				if (*(SInt16*)(1+s)>0)
					continue; /* invalid */
				if (next_name[0]==0 && (1&*(UInt16*)(1+s))==0)
					if (p!=NULL)
					{ /* breaking for an unnamed module */
						*(UInt16*)next_name = '\001,', *next = -1+s;
						return (Ptr)p; /* previous RTS/RTD/JMP(A0) */
					} else if (b!=NULL)
					{
						*(UInt16*)next_name = '\001', *next = -1+s;
						return (Ptr)b; /* previous branch island */
					}
				s += 2; continue; /* skip literal */
			} else if ((c+=0x56-0xFA)==0) /* JMP *+xxxx */
				goto bcc_w;
			continue;
		} else if ((c+=0x4E-0x60)==0) /* test for branch islands; 2007.12.11 20:30 GMT */
		{
			if (*s!=0xFF)
			{
				if (near)
					goto bcc_bw;
				continue;
			}
			if (b==NULL)
				b = s-1, s += 4;
			continue;
		} else if (!near)
			continue;
		if ((c+=0x60-0x62)<=(UInt8)(0x6F-0x62)) /* BHI.x .. BLE.x */
		{
			if (*s==0xFF) /* Bxx.L */
			{
				if (b==NULL)
					b = s-1, s += 4;
				continue;
			}
		bcc_bw:
			if (*s==0x00) /* Bxx.W */
			{
			bcc_w:
				s += 2;
				if ((t=1+*((SInt16*)(s-1))+s)>nb)
					nb = t;
			} else if ((t=1+*s+s)>nb) /* Bxx.S */
				nb = t;
		} else
			s += get_instruction_size((Ptr)s-1,(Ptr)e)-2;
		/*b = NULL; // not BRA.L; initialize pointer to branch island */
	} while(++s<e);

	if (p!=NULL) /* fix for terminal module (2008.04.15 20:15 GMT) */
		*next = p+2, *(UInt16*)next_name = '\001,';
	else
		*next = NULL;

	return code_end;
}

void lower_operands(UInt8 *s, int length)
{
	UInt8			*e = length+s, c;
	Boolean			w = true;

	if (s==NULL || length<=0 || *s==';')
		return;
	do
	{
		if ((c=*s+++-'$')==0)
			{w = false; continue;} /* hex (remains in uppercase) */
		if ((c+='$'-'0')<=(UInt8)('9'-'0') || (c+='0'-'a')<=(UInt8)('z'-'a'))
			continue; /* digit or lowercase (skip) */
		if ((c+='a'-'A')>(UInt8)('Z'-'A'))
			{w = true; continue;} /* any other non-alphabetic char (reset) */
		if (w)
			s[-1] = c+='a';/*tolower(s[-1]);*/
	} while(s<e);
}

#if __SC__ && !defined(__powerc)
# pragma segment crc
#endif

UInt32 calculate_crc32(void *d, long c, UInt32 v)
{ /* crc32 code self contained! */
	static const UInt32		crc_table[256] =
	{
		0x00000000, 0x77073096, 0xEE0E612C, 0x990951BA,
		0x076DC419, 0x706AF48F, 0xE963A535, 0x9E6495A3,
		0x0EDB8832, 0x79DCB8A4, 0xE0D5E91E, 0x97D2D988,
		0x09B64C2B, 0x7EB17CBD, 0xE7B82D07, 0x90BF1D91,
		0x1DB71064, 0x6AB020F2, 0xF3B97148, 0x84BE41DE,
		0x1ADAD47D, 0x6DDDE4EB, 0xF4D4B551, 0x83D385C7,
		0x136C9856, 0x646BA8C0, 0xFD62F97A, 0x8A65C9EC,
		0x14015C4F, 0x63066CD9, 0xFA0F3D63, 0x8D080DF5,
		0x3B6E20C8, 0x4C69105E, 0xD56041E4, 0xA2677172,
		0x3C03E4D1, 0x4B04D447, 0xD20D85FD, 0xA50AB56B,
		0x35B5A8FA, 0x42B2986C, 0xDBBBC9D6, 0xACBCF940,
		0x32D86CE3, 0x45DF5C75, 0xDCD60DCF, 0xABD13D59,
		0x26D930AC, 0x51DE003A, 0xC8D75180, 0xBFD06116,
		0x21B4F4B5, 0x56B3C423, 0xCFBA9599, 0xB8BDA50F,
		0x2802B89E, 0x5F058808, 0xC60CD9B2, 0xB10BE924,
		0x2F6F7C87, 0x58684C11, 0xC1611DAB, 0xB6662D3D,
		0x76DC4190, 0x01DB7106, 0x98D220BC, 0xEFD5102A,
		0x71B18589, 0x06B6B51F, 0x9FBFE4A5, 0xE8B8D433,
		0x7807C9A2, 0x0F00F934, 0x9609A88E, 0xE10E9818,
		0x7F6A0DBB, 0x086D3D2D, 0x91646C97, 0xE6635C01,
		0x6B6B51F4, 0x1C6C6162, 0x856530D8, 0xF262004E,
		0x6C0695ED, 0x1B01A57B, 0x8208F4C1, 0xF50FC457,
		0x65B0D9C6, 0x12B7E950, 0x8BBEB8EA, 0xFCB9887C,
		0x62DD1DDF, 0x15DA2D49, 0x8CD37CF3, 0xFBD44C65,
		0x4DB26158, 0x3AB551CE, 0xA3BC0074, 0xD4BB30E2,
		0x4ADFA541, 0x3DD895D7, 0xA4D1C46D, 0xD3D6F4FB,
		0x4369E96A, 0x346ED9FC, 0xAD678846, 0xDA60B8D0,
		0x44042D73, 0x33031DE5, 0xAA0A4C5F, 0xDD0D7CC9,
		0x5005713C, 0x270241AA, 0xBE0B1010, 0xC90C2086,
		0x5768B525, 0x206F85B3, 0xB966D409, 0xCE61E49F,
		0x5EDEF90E, 0x29D9C998, 0xB0D09822, 0xC7D7A8B4,
		0x59B33D17, 0x2EB40D81, 0xB7BD5C3B, 0xC0BA6CAD,
		0xEDB88320, 0x9ABFB3B6, 0x03B6E20C, 0x74B1D29A,
		0xEAD54739, 0x9DD277AF, 0x04DB2615, 0x73DC1683,
		0xE3630B12, 0x94643B84, 0x0D6D6A3E, 0x7A6A5AA8,
		0xE40ECF0B, 0x9309FF9D, 0x0A00AE27, 0x7D079EB1,
		0xF00F9344, 0x8708A3D2, 0x1E01F268, 0x6906C2FE,
		0xF762575D, 0x806567CB, 0x196C3671, 0x6E6B06E7,
		0xFED41B76, 0x89D32BE0, 0x10DA7A5A, 0x67DD4ACC,
		0xF9B9DF6F, 0x8EBEEFF9, 0x17B7BE43, 0x60B08ED5,
		0xD6D6A3E8, 0xA1D1937E, 0x38D8C2C4, 0x4FDFF252,
		0xD1BB67F1, 0xA6BC5767, 0x3FB506DD, 0x48B2364B,
		0xD80D2BDA, 0xAF0A1B4C, 0x36034AF6, 0x41047A60,
		0xDF60EFC3, 0xA867DF55, 0x316E8EEF, 0x4669BE79,
		0xCB61B38C, 0xBC66831A, 0x256FD2A0, 0x5268E236,
		0xCC0C7795, 0xBB0B4703, 0x220216B9, 0x5505262F,
		0xC5BA3BBE, 0xB2BD0B28, 0x2BB45A92, 0x5CB36A04,
		0xC2D7FFA7, 0xB5D0CF31, 0x2CD99E8B, 0x5BDEAE1D,
		0x9B64C2B0, 0xEC63F226, 0x756AA39C, 0x026D930A,
		0x9C0906A9, 0xEB0E363F, 0x72076785, 0x05005713,
		0x95BF4A82, 0xE2B87A14, 0x7BB12BAE, 0x0CB61B38,
		0x92D28E9B, 0xE5D5BE0D, 0x7CDCEFB7, 0x0BDBDF21,
		0x86D3D2D4, 0xF1D4E242, 0x68DDB3F8, 0x1FDA836E,
		0x81BE16CD, 0xF6B9265B, 0x6FB077E1, 0x18B74777,
		0x88085AE6, 0xFF0F6A70, 0x66063BCA, 0x11010B5C,
		0x8F659EFF, 0xF862AE69, 0x616BFFD3, 0x166CCF45,
		0xA00AE278, 0xD70DD2EE, 0x4E048354, 0x3903B3C2,
		0xA7672661, 0xD06016F7, 0x4969474D, 0x3E6E77DB,
		0xAED16A4A, 0xD9D65ADC, 0x40DF0B66, 0x37D83BF0,
		0xA9BCAE53, 0xDEBB9EC5, 0x47B2CF7F, 0x30B5FFE9,
		0xBDBDF21C, 0xCABAC28A, 0x53B39330, 0x24B4A3A6,
		0xBAD03605, 0xCDD70693, 0x54DE5729, 0x23D967BF,
		0xB3667A2E, 0xC4614AB8, 0x5D681B02, 0x2A6F2B94,
		0xB40BBE37, 0xC30C8EA1, 0x5A05DF1B, 0x2D02EF8D,
	};

	UInt8			*p = (UInt8*)d;

	if (c<=0)
		return v;
#if 0x00FFFFFFUL==-1UL>>8
	do{v = (v>>8)^crc_table[((UInt8)v^*p++)];} while(--c!=0);
#else
	do{v = ((v>>8)&0xFFFFFFUL)^crc_table[((UInt8)v^*p++)];} while(--c!=0);
#endif
	return v;
}

#if __SC__ && !defined(__powerc)
# pragma segment DisAsmExtensions
#endif

enum
{ /* selector instruction operand types */
	_op_SP, /* 0 - placeholder */
	_op_SP_B,
	_op_SP_W,
	_op_SP_L,
	_op_D0, /* 4 - placeholder */
	_op_D0_B,
	_op_D0_W,
	_op_D0_L,
	_op_D1, /* 8 - placeholder */
	_op_D1_B,
	_op_D1_W,
	_op_D1_L,
	_op_D2, /* 12 - placeholder */
	_op_D2_B,
	_op_D2_W,
	_op_D2_L,

  /* new (internal) operand flags */
	_op_SP_Dx
};

# define _FLAG_SANE_OPERAND_FORMAT_BITS		0x01 /* all types */
# define _FLAG_SANE_ELEMS_FORMAT_BITS		0x02 /* extended type only */
# define _FLAG_MASK2_IS_DEFAULT_VALUE		0x04 /* (not used) */
# define _FLAG_MASK1_IS_ONLY_VALUE			0x08 /* singles -> selector2 */
# define _FLAG_SUFFIX_SYNC_WORD				0x10 /* suffixes sync word depending on A2xx/A6xx */
# define _FLAG_DUALS_SKIP_SYNC_WORD			0x20 /* no sync suffix for dual selectors */
# define _FLAG_MATCHING_TRAP_WORD_BITS		0x40 /* selector data values that have bits must match */
# define _FLAG_ACCEPT_SYNC_WORD				0x80 /* allow as alternative (if trapword does not match) */

#if 0
typedef struct selector_single_data
{
	UInt32			selector1;
	UInt8			name[1];
} selector_single_data;

typedef struct selector_dual_data
{
	UInt32			selector1, selector2;
	UInt8			name[1];
} selector_dual_data;
#endif

typedef struct trap_selector_data
{
	UInt8			trap_name[32]; /* may be blank */

	UInt8			prefix[8], suffix[8]; /* may be blank */
	UInt32			selector1_mask, selector2_mask;
	UInt8			selector_flags, selector_types;
	UInt16			single_count;
	UInt8			data[1];
	/* selector_single_data	data[1]; -- variable count */
	/* followed by dual count, selector_dual_data */
} trap_selector_data;

/* moved this out, added second selector for (UppercaseText,... etc.); 2008.04.19 06:44 GMT*/
static SInt32 get_instruction_placement_value(const char *p, UInt8 *_w)
{
	UInt8			h = *p++, w = _op_XX;
	SInt32			m = 0;

	/* SC does switch's like dung */
	if ((h+=-0x42)!=0)
	{
		if (((h+=0x42-0x70)&0x80)==0)
		{
			if (h==0) /* MOVEQ xx,D0 */
				m = *p, w = _op_D0_L;
			else if ((h+=0x70-0x72)==0) /* MOVEQ xx,D1 */
				m = *p, w = _op_D1_L;
			else if ((h+=0x72-0x74)==0) /* MOVEQ xx,D1 */
				m = *p, w = _op_D2_L;
		} else if (*p!=0x3C)
		{
			if ((w=*p+1<<4)>_op_D2_L)
				w = _op_XX;
			else if ((h+=0x70-0x1F)==0)
				w = _op_SP_Dx|_op_XX_B;
			else if ((h+=0x1F-0x2F)==0)
				w = _op_SP_Dx|_op_XX_L;
			else if ((h+=0x2F-0x3F)==0)
				w = _op_SP_Dx|_op_XX_W;
			else
				w = _op_XX;
			return 0;
		}
		if ((h+=0x70-0x10)==0) /* MOVE.B xx,D0 */
			m = *(UInt8*)(2+p), w = _op_D0_B;
		else if ((h+=0x10-0x11)==0) /* MOVE.B xx,D1 */
			m = *(UInt8*)(2+p), w = _op_D1_B;
		else if ((h+=0x11-0x12)==0) /* MOVE.B xx,D2 */
			m = *(UInt8*)(2+p), w = _op_D2_B;
		else if ((h+=0x12-0x1F)==0) /* MOVE.B xx**,-(A7) */
			m = *(UInt8*)(2+p), w = _op_SP_B;
		else if ((h+=0x1F-0x20)==0) /* MOVE.L xxxxxxxx,D0 */
			m = *(UInt32*)(1+p), w = _op_D0_L;
		else if ((h+=0x20-0x21)==0) /* MOVE.L xxxxxxxx,D1 */
			m = *(UInt32*)(1+p), w = _op_D1_L;
		else if ((h+=0x21-0x22)==0) /* MOVE.L xxxxxxxx,D2 */
			m = *(UInt32*)(1+p), w = _op_D2_L;
		else if ((h+=0x22-0x2F)==0) /* MOVE.L xxxxxxxx,-(A7) */
			m = *(UInt32*)(1+p), w = _op_SP_L;
		else if ((h+=0x2F-0x30)==0) /* MOVE.W xxxx,D0 */
			m = *(UInt16*)(1+p), w = _op_D0_W;
		else if ((h+=0x30-0x31)==0) /* MOVE.W xxxx,D1 */
			m = *(UInt16*)(1+p), w = _op_D1_W;
		else if ((h+=0x31-0x32)==0) /* MOVE.W xxxx,D2 */
			m = *(UInt16*)(1+p), w = _op_D2_W;
		else if ((h+=0x32-0x3F)==0) /* MOVE.W xxxx,-(A7) */
			m = *(UInt16*)(1+p), w = _op_SP_W;
	} else if ((h=*p)==0x00) /* CLR.B D0 */
		w = _op_D0_B;
	else if ((h+=0x00-0x01)==0) /* CLR.B D1 */
		w = _op_D1_B;
	else if ((h+=0x01-0x02)==0) /* CLR.B D2 */
		w = _op_D2_B;
	else if ((h+=0x02-0x17)==0) /* CLR.B (A7) -- supported (barely) */
		w = _op_SP_B;
	else if ((h+=0x17-0x27)==0) /* CLR.B -(A7) */
		w = _op_SP_B;
	else if ((h+=0x27-0x40)==0) /* CLR.W D0 */
		w = _op_D0_W;
	else if ((h+=0x40-0x41)==0) /* CLR.W D1 */
		w = _op_D1_W;
	else if ((h+=0x41-0x42)==0) /* CLR.W D2 */
		w = _op_D2_W;
	else if ((h+=0x42-0x50)==0) /* CLR.W (A7) -- */
		w = _op_SP_W;
	else if ((h+=0x50-0x67)==0) /* CLR.W -(A7) */
		w = _op_SP_W;
	else if ((h+=0x67-0x80)==0) /* CLR.L D0 */
		w = _op_D0_L;
	else if ((h+=0x80-0x81)==0) /* CLR.L D1 */
		w = _op_D1_L;
	else if ((h+=0x81-0x82)==0) /* CLR.L D2 */
		w = _op_D2_L;
	else if ((h+=0x82-0x90)==0) /* CLR.L (A7) -- */
		w = _op_SP_L;
	else if ((h+=0x90-0xA7)==0) /* CLR.L -(A7) */
		w = _op_SP_L;

	if (_w!=NULL)
		*_w = w;

	return m;
}

/* now returns an error code */
int make_atrap_strings(const Ptr p,
	const Ptr p2, /* can be NULL */
	UInt16 t,
	UInt8 *a,
	UInt8 *_b,
	UInt8 *c)
{
	/* SANE Format Types: Extended, Double, Single, any(???), Integer, Long, Comp, ??? */
	static const char	format_types[] = "EDSZILC?";

	Handle			h;

	const trap_selector_data	*traps_data = NULL;

	const UInt8		*r = NULL;
	UInt16			trapword = 0xFFFF, x;
	UInt8			*g = NULL, *b = _b, w = _op_XX, w2 = _op_XX, z, add_prefix = 1;
	SInt32			m, m1, m2, n = -1; /* `m` is a copy for the SANE bits eval. */
	Boolean			dual = 0xFF, force_trap_name = false, add_suffix = false;

	if (t==0xA8A4) /* to replace the obsolete name */
		*(UInt32*)a = '\013_In', *(UInt32*)(4+a) = 'vert', *(UInt32*)(8+a) = 'Rect';
	else
		LookupTrapName(trapword=t,a);
	if ((z=a[0])==0)
		*(SInt32*)a = '\004DC.', a[4] = 'W', force_trap_name = true;
	else
	{ /* somehow '_' only appeared when switching to far model... */
		if (a[1]!='_' && z<126)
		{ /* manually put the '_' before the string */
			UInt8		*d = 1+z+a;

			do{d[1] = *--d;} while(--z!=0);
			++a[0], a[1] = '_';
		}
		b[0] = 0; /* also clear the unneeded operands (the name replaces it) */

		if (*(SInt32*)a=='\004DC.')
			force_trap_name = true;
	}

	if (*(SInt32*)a=='\004DC.')
	{
		force_trap_name = false;
		if (t==0xAAF1)
			*(UInt32*)a = '\013_at', *(UInt32*)(4+a) = 'aMan', *(UInt32*)(8+a) = 'ager', b[0] = 0;
		else if (t==0xA51D)
			*(UInt32*)a = '\012_Ma', *(UInt32*)(4+a) = 'xMem', *(UInt16*)(8+a) = 'Sys\0', b[0] = 0;
		else if ((t&0xF81D)==0xA01D)
			*(UInt32*)a = '\007_Ma', *(UInt32*)(4+a) = 'xMem', b[0] = 0;
		else if (t==0xA403) /* damn; 2008.06.27 09:14 GMT */
			*(UInt32*)a = '\015_PB', *(UInt32*)(4+a) = 'Writ', *(UInt32*)(8+a) = 'eAsy', *(UInt16*)(12+a) = 'nc', b[0] = 0;
		else if (t==0xA203) /* double damn...; 2008.06.27 09:25 GMT */
			*(UInt32*)a = '\015_PB', *(UInt32*)(4+a) = 'Writ', *(UInt32*)(8+a) = 'eImm', *(UInt16*)(12+a) = 'ed', b[0] = 0;
		else if (t==0xA406)
			*(UInt32*)a = '\014_PB', *(UInt32*)(4+a) = 'Kill', *(UInt32*)(8+a) = 'Asyn', a[12] = 'c', b[0] = 0;
		else if (t==0xA206)
			*(UInt32*)a = '\014_PB', *(UInt32*)(4+a) = 'Kill', *(UInt32*)(8+a) = 'Imme', a[12] = 'd', b[0] = 0;
		else
			force_trap_name = true;
	}

	if (c[0]>249) /* length overflow on third string */
		return 0;
	if (c!=_b)
		if ((t&0x0800)==0)
		{ /* set up flags for OS Trap: Restore(???), Immed, System */
			if ((z=c[0]+=4)==4)
				*(UInt16*)c = '\005;';
			c[z-3] = ' ';
			c[z-2] = (t&0x100) ? 'R':'r';
			c[z-1] = (t&0x200) ? 'I':'i';
			c[z-0] = (t&0x400) ? 'S':'A'; /* was 'S':'s' */
			t &= 0xA6FF;
		} else
		{ /* only one flag for Toolbox Traps: Autopop */
			if ((z=c[0]+=2)==2)
				*(UInt16*)c = '\003;';
			c[z-1] = ' ';
			c[z-0] = (t&0x400) ? 'P':'p';
			t &= 0xABFF;
		}

	if (p==NULL)
		return 0;

	/* trap selector names */

	/* get the literal operand(s) from the previous instruction(s) */
	m1 = m = get_instruction_placement_value(p,&w);
	m2 = get_instruction_placement_value(p2,&w2);
	if (w==_op_XX && !force_trap_name) /* needs a name; 2008.05.22 02:54 GMT */
		return 0;
	if (w&_op_SP_Dx)
	{ /* advanced placement - MOVEQ Dx; MOVE Dx,-(SP); 2008.05.20 22:58 GMT */
		/* use lowest size */
		if ((w2&=_op_XX_L)==_op_XX)
			return 0;
		w = (w&~_op_XX_L)|(w2<(w&_op_XX_L) ? w2:(w&_op_XX_L));
		m1 = m2;
	}

	/* get the associated selector resource for the trap - slow form for now */
	if ((h=Get1Resource('rTrS',t-0xA000))!=NULL) /* would be GetResource, but performance, contamination... */
		traps_data = *(const trap_selector_data**)h;
	/*else if ((t&0xA600)==0xA600 && (h=Get1Resource('rTrS',t-0xA400))!=NULL)*/
	else if ((t&0x800)==0 && (h=Get1Resource('rTrS',t&0x1FF))!=NULL) /*t&~0xA400*/
		if (((traps_data=*(const trap_selector_data**)h)->selector_flags&_FLAG_ACCEPT_SYNC_WORD)==0)
			return 0;
	//HLock(h);
	//HNoPurge(h);
	/* no need to lock -- no functions will be called from here on */
	/* the resources retrieved should be Purgeable */
	if (traps_data==NULL)
		return 0;
	if (w==_op_XX)
		goto tname;

	/* replace unset bits with whatever invalid/unlikely to signal unset */
	if ((w&_op_XX_L)==_op_XX_W)
		m1 &= 0xFFFF, m1 |= 0xABCD0000;
	else if ((w&_op_XX_L)==_op_XX_B)
		m1 &= 0xFF, m1 |= 0xABCDEF00;
	if ((w2&_op_XX_L)==_op_XX_W)
		m2 &= 0xFFFF, m2 |= 0xABCD0000;
	else if ((w2&_op_XX_L)==_op_XX_B)
		m2 &= 0xFF, m2 |= 0xABCDEF00;

	/* special manuevers! */
	if (w==_op_SP_W && (traps_data->selector_types&(_op_XX_L<<4))==_op_SP_B<<4)
		m1 >>= 8;
	if (w==_op_SP_L && (traps_data->selector_types&(_op_XX_L<<4))==_op_SP_W<<4)
		m1 >>= 16;
	else if (w==_op_SP_L && (traps_data->selector_types&(_op_XX_L<<4))==_op_SP_B<<4)
		m1 >>= 24;

	if (w2==_op_SP_W && (traps_data->selector_types&_op_XX_L)==_op_SP_B)
		m2 >>= 8;
	if (w2==_op_SP_L && (traps_data->selector_types&_op_XX_L)==_op_SP_W)
		m2 >>= 16;
	else if (w2==_op_SP_L && (traps_data->selector_types&_op_XX_L)==_op_SP_B)
		m2 >>= 24;

	if ((w&_op_XX_L)<(traps_data->selector_types&_op_XX_L))
		goto tname;
	if (traps_data->selector_flags&_FLAG_MASK1_IS_ONLY_VALUE)
	{ /* "singles" array does selector2 instead */
		if (m1!=traps_data->selector1_mask)
			goto tname;
		m1 = m2&traps_data->selector2_mask;
	} else
		m1 &= traps_data->selector1_mask, m2 &= traps_data->selector2_mask;

	if ((traps_data->selector_types&_op_XX_L)<=_op_XX_W)
		n = 0x0FFFFFFF, ++add_prefix;
	/* scan the single selector names */
	r = traps_data->data;
	if ((x=traps_data->single_count)!=0)
		if (traps_data->selector_flags&_FLAG_MATCHING_TRAP_WORD_BITS)
			do
			{
				SInt32		t;

				if ((t=*((SInt32*)r)++)&0x80000000)
				{ /* bit 31: matching; bits 28-31: mask; bits 24-27: bits */
					if (((trapword<<20)&t)!=(t&0x0F000000))
						goto next1;
					t &= 0x00FFFFFF;
				}
				if (t==m1) /* selector */
					{dual = false, n = *(-1+(SInt32*)r); goto found;}
			next1:
				r += *r++;
			} while(--x!=0);
		else
			do
			{
				if ((n&*((SInt32*)r)++)==m1) /* selector */
					{dual = false, n = ((SInt32*)r)[-1]; goto found;}
				r += *r++;
			} while(--x!=0);
		

	/* scan the dual selector names */
	if ((x=*((UInt16*)r)++)!=0)
	{
		long			resource_size = GetHandleSize(h);

		if ((Ptr)r>resource_size+*h)
		{
			/*fprintf(stderr,"## make_atrap_strings: data, counts (offset 0x%06X) > length 0x%06X!\n", (Ptr)r-*h,resource_size);*/
			return eofErr;
		}
		if (traps_data->selector_flags&_FLAG_MATCHING_TRAP_WORD_BITS)
			do
			{
				SInt32		t; /* selector1 */

				if ((t=*((SInt32*)r)++)&0x80000000)
				{ /* bit 31: matching; bits 28-31: mask; bits 24-27: bits */
					if (((trapword<<20)&t)!=(t&0x0F000000))
						{r += 4; goto next2;}
					t &= 0x00FFFFFF;
				}
				if (*((SInt32*)r)++==m2 && t==m1) /* selector2 */
					{dual = true, n = *(-2+(SInt32*)r); goto found;}
			next2:
				r += *r++; /* title Pascal string */
			} while(--x!=0);
		else
			do
			{
				SInt32		t = n&*((SInt32*)r)++; /* selector1 */

				if (*((SInt32*)r)++==m2 && t==m1) /* selector2 */
					{dual = true, n = ((SInt32*)r)[-2]; goto found;}
				r += *r++; /* title Pascal string */
			} while(--x!=0);
	}
	if (x==0)
		goto tname;
found:
	if (c!=_b)
		if (traps_data->selector_flags&_FLAG_SANE_OPERAND_FORMAT_BITS)
		{
			c[++z] = ' ';
			c[++z] = format_types[(m>>11)&7];
			if ((m&0x20)!=0)
				c[++z] = 'X'; /* 96 bit extension */
			c[0] = z;
		} else if (traps_data->selector_flags&_FLAG_SANE_ELEMS_FORMAT_BITS)
		{
			c[++z] = ' ';
			if ((m&0x80)!=0)
				c[++z] = 'X'; /* 96 bit extension */
			c[0] = z;
		}

	if (dual && (traps_data->selector_flags&_FLAG_DUALS_SKIP_SYNC_WORD))
	{
		if ((trapword&0x600)!=0x200)
			goto tname;
	} else if (traps_data->selector_flags&_FLAG_SUFFIX_SYNC_WORD)
		if (trapword&0x200)
			g = "\pSync";
		else if ((trapword&0x600)==0x600)
			g = "\pAsync";

	z = *r++;
	/* negative selectors with short mask -> bitnot, no prefix; 2008.05.22 09:39 GMT */
	if (traps_data->prefix[0]>7 || ((n&(long)0x80000000) && add_prefix==2
			&& (traps_data->selector_flags&_FLAG_MATCHING_TRAP_WORD_BITS)==0))
		m1 = 0, add_prefix = false;
	else
		m1 = traps_data->prefix[0];
	if (g==NULL)
		m1 += 1+z;
	else
		m1 += 1+z+*g++;

	if (m1>255)
	{
		*b++ = 255;
		if ((m1=-m1+z+255)<0)
			return -1; /* total bust */
		z = m1;
	} else
	{
		if (traps_data->suffix[0]<=7 && m1+traps_data->suffix[0]<=255)
			m1 += traps_data->suffix[0], add_suffix = true;
		*b++ = m1;
	}
	*b++ = ';';

	if (add_prefix)
	{
		const UInt8		*s = traps_data->prefix;

		switch(*s++)
		{
		case 7: *b++ = *s++;
		case 6: *b++ = *s++;
		case 5: *b++ = *s++;
		case 4: *b++ = *s++;
		case 3: *b++ = *s++;
		case 2: *b++ = *s++;
		case 1: *b++ = *s++;
			break; /* anything else adds nothing */
		}
	}

	if (z!=0)
	{
	copy:
		if (z&1)
			*b++ = *r++;
		if (z&2)
			*((UInt16*)b)++ = *((UInt16*)r)++;
		if (z&4)
			*((UInt32*)b)++ = *((UInt32*)r)++;
		if ((z&=-8)!=0)
			do{*((UInt32*)b)++ = *((UInt32*)r)++; *((UInt32*)b)++ = *((UInt32*)r)++;}while((z+=-8)!=0);
	}
	r = traps_data->suffix; /* suffix comes before sync-word */
	if (add_suffix && (z=*r++)!=0)
		do{*b++ = *r++;} while(--z!=0);
	if ((r=g)!=NULL && (z=g[-1])!=0)
		do{*b++ = *r++;} while(--z!=0);
	/*if (!force_trap_name)
		return 0;*/
tname:
	r = traps_data->trap_name;
	if ((unsigned)((z=*r++)-1)>sizeof(traps_data->trap_name)-2) /* lengths must be valid! */
		return 0;
	if (*r==';') /* alternate name (only) */
		return 0;
	if (*(UInt16*)_b=='\005$')
		_b[0] = 0;

	b = a, *b++ = 1+z, *b++ = '_';
	if (z&1)
		*b++ = *r++;
	if (z&2)
		*((UInt16*)b)++ = *((UInt16*)r)++;
	if (z&4)
		*((UInt32*)b)++ = *((UInt32*)r)++;
	if ((z&=-8)!=0)
		do{*((UInt32*)b)++ = *((UInt32*)r)++; *((UInt32*)b)++ = *((UInt32*)r)++;}while((z+=-8)!=0);
	return 0;
}
#else
/*
 reveng.c
  A worst nightmare.  A MUCH better revision of the stupid DStack program.

  Created: 2007.12.03 16:42 GMT

Saturday, May 31, 2008 7:10 AM
  concluded the entire CIncludes in selector information (many, many man hours total).
*/
#define REVISION_DATE_STR					"2008.08.25 04:32 GMT"
#define VERSION_STR							"1.2.4a1"

#include <string.h>
/*#include <ctype.h>*/
#include <errno.h>

#include <Resources.h>
#include <MacMemory.h>
#include <MacErrors.h>

#include <FSpio.h>

#if TARGET_CPU_PPC
# define GENERATION_STR						" (PPC)"
#elif TARGET_CPU_X86
# define GENERATION_STR						" (i386)"
#else
# define GENERATION_STR						""
#endif

#if TARGET_OS_MAC
# define commandPeriod()					((*((volatile UInt8*)0x179)&*((volatile UInt8*)0x17A))!=0)
#else
# define commandPeriod()					0 /* you lose */
#endif

#define EXT_SEGMENT_HEADER_SIZE				40

enum
{
	_module_code_type, /* placeholder */
	_module_boffset_type,
	_module_heading_type,
	_module_coderef_type,
	_module_data_type, /* placeholder */
	_module_dataref_type
};


/* ---- globals */

UInt8			temporary[1024] = {0}; /* 1KB */

static Boolean		user_abort = false;

static long			label_counter = 0, module_counter = 0, code_ref_counter = 0;
static long			trailer_count = 0, code_relocation_count = 0;
static long			anon_count = 0, branch_island_count = 0, case_count = 0;
static long			**stored_offsets = NULL, stored_offset_count = 0;
static int			tab_width = 4;

static OSType		code_type = DEFAULT_CODETYPE;

/* these are used for making base strings (hex) and labels (base 36) */
/* I woulda removed some to eliminate indecent words, but then I said F**k it. */
static const char	ubasechars[] = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ";
static const char	lbasechars[] = "0123456789abcdefghijklmnopqrstuvwxyz";

/* ---- code */

static void global_idle_proc()
{
	if (user_abort)
	{
		fputs("\n### User abort.\n",stderr);
		exit(1);
	}
	if (commandPeriod())
		user_abort = true;
}

/* ---- disassembly */

Boolean add_offset_label(long offset);

static void print_compressed_offsets(UInt8 *data,
	long max_length,
	const char *offsets_only_str) /* optional string; 2008.06.19 00:23 GMT */
{
	const char		*offset_str;
	UInt8			*data_end = max_length+data;
	long			offset = 0;

	/* added; 2008.05.30 12:26 */
	switch(tab_width)
	{
	case 1: offset_str = ";\t\t\t\t\t\t\t%02X"; break;
	case 2: offset_str = ";\t\t\t\t%02X"; break;
	case 3: offset_str = ";\t\t\t%02X"; break;
	case 4: offset_str = ";\t\t%02X"; break;

	default: offset_str = ";\t%02X";
	}

	do
	{
		int			tabulation = 6;

		global_idle_proc();
		if (user_abort)
			return;

		if (offsets_only_str==NULL)
			printf(offset_str, *(UInt8*)data);
		if (*data++==0)
		{
			if (*data==0)
			{
				if (offsets_only_str==NULL)
					printf(" 00\n; End of relocation table\n\n");
				break;
			}
			if (offsets_only_str==NULL)
				printf(" %08X", *(UInt32*)data);
			tabulation -= 2, offset += *((SInt32*)data)++;
		} else if ((data[-1]&0x80)!=0)
		{
			if (offsets_only_str==NULL)
				printf(" %02X", *data), --tabulation;
			offset += -32768, offset += ((UInt16*)(++data))[-1];
		} else
			offset += data[-1];
		if (offsets_only_str!=NULL)
			printf(offsets_only_str, ++code_relocation_count,offset+offset-2);
		else
		{
			do{fputc('\t',stdout);} while(--tabulation>=0);
			printf("; %08X\n", offset+offset);
		}
	} while(data<data_end);
}

static void print_char_data(UInt8 c)
{
	fputc(c<' ' || c==0x7F ? '.':c,stdout);
}

static void print_local_offset(long offset)
{
	if (offset>=0)
		printf("+%06X\t", offset);
	else
		printf("-%06X\t", -offset);
}

static void print_trailer(const void *_s,
	const void *_e,
	void *m,
	long int z,
	long int o,
	Boolean u,
	Boolean v)
{
	const char		*dcwstr, *dcbstr, *aspstr, *tspstr;

	const UInt8		*s, *e;

	/* added; 2008.05.30 12:35 */
	switch((tab_width<<1)|u)
	{ /* ugly, but fast */
	case 2: dcwstr = "\t\t\t\tdc.w\t\t\t\t\t\t\t\t\t\t\t\t", dcbstr = "\t\t\t\tdc.b\t\t\t\t\t\t\t\t\t\t\t\t", tspstr = aspstr = "\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t"; break;
	case 3: dcwstr = "\t\t\t\tDC.W\t\t\t\t\t\t\t\t\t\t\t\t", dcbstr = "\t\t\t\tDC.B\t\t\t\t\t\t\t\t\t\t\t\t", tspstr = aspstr = "\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t"; break;
	case 4: dcwstr = "\t\tdc.w\t\t\t\t\t\t", dcbstr = "\t\tdc.b\t\t\t\t\t\t", aspstr = "\t\t\t\t\t\t\t\t", tspstr = "\t\t\t\t\t\t\t\t\t"; break;
	case 5: dcwstr = "\t\tDC.W\t\t\t\t\t\t", dcbstr = "\t\tDC.B\t\t\t\t\t\t", aspstr = "\t\t\t\t\t\t\t\t", tspstr = "\t\t\t\t\t\t\t\t\t"; break;
	case 6: dcwstr = "\tdc.w\t\t\t\t", dcbstr = "\tdc.b\t\t\t\t", aspstr = "\t\t\t\t\t", tspstr = "\t\t\t\t\t\t\t\t"; break;
	case 7: dcwstr = "\tDC.W\t\t\t\t", dcbstr = "\tDC.B\t\t\t\t", aspstr = "\t\t\t\t\t", tspstr = "\t\t\t\t\t\t\t\t"; break;
	case 8: dcwstr = "\tdc.w\t\t\t", dcbstr = "\tdc.b\t\t\t", aspstr = "\t\t\t\t", tspstr = "\t\t\t\t\t\t"; break;
	case 9: dcwstr = "\tDC.W\t\t\t", dcbstr = "\tDC.B\t\t\t", aspstr = "\t\t\t\t", tspstr = "\t\t\t\t\t\t"; break;
	case 10: dcwstr = "\tdc.w\t\t", dcbstr = "\tdc.b\t\t", aspstr = "\t\t\t", tspstr = "\t\t\t\t"; break;
	case 11: dcwstr = "\tDC.W\t\t", dcbstr = "\tDC.B\t\t", aspstr = "\t\t\t", tspstr = "\t\t\t\t"; break;
	case 12: case 14: dcwstr = "\tdc.w\t", dcbstr = "\tdc.b\t", aspstr = "\t\t", tspstr = "\t\t\t"; break;
	case 13: case 15: dcwstr = "\tDC.W\t", dcbstr = "\tDC.B\t", aspstr = "\t\t", tspstr = "\t\t\t"; break;
	case 16: case 18: dcwstr = "\tdc.w\t", dcbstr = "\tdc.b\t", aspstr = "\t\t", tspstr = "\t\t"; break;
	case 17: case 19: dcwstr = "\tDC.W\t", dcbstr = "\tDC.B\t", aspstr = "\t\t", tspstr = "\t\t"; break;

	default: dcwstr = u ? "\tDC.W\t":"\tdc.w\t", dcbstr = u ? "\tDC.B\t":"\tdc.b\t", aspstr = tspstr = "\t";
	}

	if ((s=(UInt8*)_s)==NULL || z<=0)
		return;
	if ((e=(UInt8*)_e)==NULL || e-s>z)
		e = z+s;
	if ((unsigned)(e-s)>(1L<<28)) /* unreasonable value */
		return;
	if (v)
		printf("; %08X\n", o);
	if ((e-=3)>s)
		do
		{
			global_idle_proc();
			if (user_abort)
				return;
			if (m!=NULL)
				print_local_offset(s-(UInt8*)m);
			else
				fputc('\t',stdout);
			/* no trailing space here; 2008.05.30 12:34 GMT */
			printf("%s$%04X, $%04X%s;", dcwstr,((UInt16*)s)[0],((UInt16*)s)[1],aspstr);
			if (*(UInt32*)s==0) /* dont print literal if all zeros; 2008.05.16 14:50, 00:10 GMT */
				{s += 4, fputc('\n',stdout); continue;}
			fputs(" \047",stdout);
			print_char_data(*s++);
			print_char_data(*s++);
			print_char_data(*s++);
			print_char_data(*s++);
			fputs("\047\n",stdout);
		} while(s<e);

	if ((e+=3)==s)
		return;

	if (m!=NULL)
		print_local_offset(s-(UInt8*)m);
	else
		fputc('\t',stdout);
	switch(e-s)
	{ /* with tab_width!=4, these may be off by some measure */
	case 1:
		printf(tab_width>2 ? "%s$%02X\t%s;":(tab_width==1 ? "%s$%02X\t\t\t\t%s;"
			:"%s$%02X\t\t%s;"), dcbstr,s[0],tspstr);
		if (s[0]==0)
			{fputc('\n',stdout); return;}
		fputs(" \047",stdout);
		print_char_data(*s);
		break;
	case 2:
		printf("%s$%04X%s;", dcwstr,*(UInt16*)s,tspstr);
		if (*(UInt16*)s==0)
			{fputc('\n',stdout); return;}
		fputs(" \047",stdout);
		print_char_data(*s++);
		print_char_data(*s);
		break;
	case 3:
		printf("%s$%02X, $%02X, $%02X%s;", dcbstr,s[0],s[1],s[2],aspstr);
		if ((s[2]|*(UInt16*)s)==0)
			{fputc('\n',stdout); return;}
		fputs(" \047",stdout);
		print_char_data(*s++);
		print_char_data(*s++);
		print_char_data(*s);
		break;
	}

	fputs("\047\n",stdout);
}

/* added; 2008.06.18 19:07 GMT */
static void print_32_bit_offsets(const void *_s,
	const void *_e,
	void *m,
	long int z,
	long int o,
	Boolean u,
	Boolean v)
{
	const UInt8		*s, *e;
	const char		*dclstr;

	switch((tab_width<<1)|u)
	{ /* ugly, but fast */
	case 2: dclstr = "\t\t\t\tdc.l\t\t\t\t\t\t\t\t\t\t\t\t"; break;
	case 3: dclstr = "\t\t\t\tDC.L\t\t\t\t\t\t\t\t\t\t\t\t"; break;
	case 4: dclstr = "\t\tdc.l\t\t\t\t\t\t"; break;
	case 5: dclstr = "\t\tDC.L\t\t\t\t\t\t"; break;
	case 6: dclstr = "\tdc.l\t\t\t\t"; break;
	case 7: dclstr = "\tDC.L\t\t\t\t"; break;
	case 8: dclstr = "\tdc.l\t\t\t"; break;
	case 9: dclstr = "\tDC.L\t\t\t"; break;
	case 10: dclstr = "\tdc.l\t\t"; break;
	case 11: dclstr = "\tDC.L\t\t"; break;

	default: dclstr = u ? "\tDC.L\t":"\tdc.l\t";
	}

	if ((s=(const UInt8*)_s)==NULL || z<=0)
		return;
	if ((e=(const UInt8*)_e)==NULL || e-s>z)
		e = z+s;
	if ((unsigned)(e-s-3)>(1L<<28)) /* unreasonable or negligible value */
		return;
	if (v)
		printf("; %08X\n", o);

	do
	{
		global_idle_proc();
		if (user_abort)
			return;
		if (m!=NULL)
			print_local_offset(s-(UInt8*)m);
		else
			fputc('\t',stdout);
		printf("%s$%08X\n", dclstr,*((UInt32*)s)++);
	} while(s<e);
}

#define MAXIMUM_NUMBER_OF_LABELS			(1000000) /* protective measure */

#define DISPLACEMENT_ERROR					2 /* adjust for negative offsets in refs */

/*
 label list format:
  list_count.u32
   entry_length.u8, type.8, label_offset.32, name[]
*/
static UInt8 *get_offset_label_str(UInt8 *l, long o, Boolean f, UInt8 y)
{
	UInt8			*s = NULL; /* closest pointer */
	UInt32			x, v = -1U, i = 0; /* remaining, closest offset difference, temporary */
	UInt32			z; /* data size (size of the current Pascal string) */

	if (l==NULL || (x=*((UInt32*)l)++)==0)
		return NULL;
	if (x>MAXIMUM_NUMBER_OF_LABELS)
		DebugStr("\pinternal string-list exceeds MAXIMUM_NUMBER_OF_LABELS!");
	/*while((z=*l++)!=0) -- previously a zero-length terminated list */
	if (f) /* first-most (must match exact value) */
		do
		{
			if ((z=*l++)>6 && *(SInt32*)(1+l)==o
					&& ((_module_code_type|_module_data_type)&*l)==y)
				return --l;
			l += z;
		} while(--x!=0);
	else /* last-most, closest (displaced reference) */
		do
		{
			/* smallest positive _underneath_ */
			/*if ((i=o-*(SInt32*)(1+l))<0)
				i = -i;*/
			if ((z=*l++)>6 && ((_module_code_type|_module_data_type)&*l)==y
					&& (i=o-*(UInt32*)(1+l))<v)
			{
				if (*l!=_module_coderef_type || i==0)
					v = i, s = l-1;
			}
#if DISPLACEMENT_ERROR!=0
			else if (v!=0 && *l==_module_boffset_type && i>=-DISPLACEMENT_ERROR)
				v = 1, s = l-1;
#endif
			l += z;
		} while(--x!=0);

	return s;
}

static Ptr print_macsbug_trailer(Ptr code,
	Ptr trailer,
	Ptr code_end,
	Ptr module_start,
	UInt8 *label_list,
	int function, /* silent but deadly */
	Boolean lower,
	Boolean tack,
	Boolean verbose)
{
	UInt8			*t, c;
	int				size = 8, i;
	Boolean			unreliable = false;

	if (((c=*trailer)&0x80)==0)
		return NULL; /* first byte must have bit 7 set to one */
	if (c==0x80)
		size = 0xFE&(3+trailer[1]);
	else if (c<=0x9F)
		size = 0x3E&((tack ? 3:2)+c);
	else if ((c+=-0x80-'%')!=0 && (c+='%'-'.')!=0 && (c+='.'-'0')>(UInt8)('9'-'0')
			&& (c+='0'-'A')>'Z'-'A' && (c+='A'-'_')!=0 && (c+='_'-'a')>'z'-'a')
		return NULL;
	else
		unreliable = true; /* trailer fix (used in MAC vs. IBM); 2008.06.27 09:03 GMT */

	trailer += size;
	/*if ((size=*((SInt16*)trailer)++)==0x00FF)*/
	if ((size=*((SInt16*)trailer)++)!=0 && unreliable)
		return trailer-2;
	if ((size&1)!=0)
	{
		if (function==0)
		{
			if (module_start!=NULL)
				print_local_offset(trailer-module_start-2);
			else
				fputc('\t',stdout);
			puts(lower ? "\tdc.w\t\t\t$00FF":"\tDC.W\t\t\t$00FF");
		}
		return trailer; /* Linker/Assembler sizing bug */
	}

	if (function!=0)
	{
		if (function>0 && size>0)
			if (add_offset_label(trailer-code))
				printf("trailerdata%04u; %08X\n", ++trailer_count,trailer-code);
		return NULL;
	}

	if (module_start!=NULL)
		print_local_offset(trailer-module_start-2);
	else
		fputc('\t',stdout);
	/* shlocky; 2008.05.30 13:08 GMT */
	printf(tab_width>4 ? "\t%s\t$%04X\t\t\t; Size of literals\n"
		:"\t%s\t\t\t$%04X\t\t\t\t\t\t; Size of literals\n",lower ? "dc.w":"DC.W",size);
	if (size>0)
	{
		if (module_start==NULL && verbose)
			printf("; %08X\n", trailer-code);

		/* print the label for the line, if found */
		if ((t=get_offset_label_str(label_list,trailer-code,true,_module_code_type))!=NULL
				&& (i=*t-5)>0)
			fwrite(6+t,1,i,stdout), fputc(':',stdout), fputc('\n',stdout);
	}

	print_trailer(trailer,code_end,module_start,size,0,!lower,false); /*~1&++size*/

	return NULL;
}

/* ---- shell code */

/* trying to put this part (two globals, two functions) in disasm extensions failed
  (code overflow) */
Ptr				temp_code_read_buffer = NULL;
short			read_code_target_rf = -1;

/* reads data silently; unread data shows up as one bits (-1, EOF) */
static Boolean read_code_resource(void *buf,
	int code_id,
	long offset,
	long size)
{
	Handle			h;
	short			old_rf = CurResFile();

	if (buf==NULL || read_code_target_rf==-1)
		return false;

	/*memset(buf,-1,size); -- init in case of failure */
	if (size>0)
	{
		UInt32		*d = (UInt32*)buf, x, v = -1UL;

		if ((x=size&-16)!=0)
			do{*d++ = v, *d++ = v, *d++ = v, *d++ = v;} while(x+=-16);

		if (size&8)
			*d++ = v, *d++ = v;
		if (size&4)
			*((UInt32*)d)++ = v;
		if (size&2)
			*((UInt16*)d)++ = v;
		if (size&1)
			*((UInt8*)d) = v;
	}

	UseResFile(read_code_target_rf);
	SetResLoad(0);
	h = Get1Resource(code_type,code_id);
	SetResLoad(1);
	UseResFile(old_rf);

	if (h==NULL)
		return false;
	if (size>0)
		ReadPartialResource(h,offset,buf,size);

	return true;
}

#define SINGLE_MODULE_MAXIMUM_SIZE			(32L<<10) /* 32KB */

static Boolean comment_to_module_name(UInt8 *out_string,
	UInt8 *comment,
	const char *basechars)
{
	static counter = 0;

	UInt8			*s, *e, c;
	void			*next_module = NULL;
	int				code_id = 0, code_offset = 0;

	if ((s=comment)==NULL || *s++<=13 || *s++!=';')
		return false;
	e = s[-2]-1+s;
	if (*s==' ')
		++s;
	if (*s++!='\047' || *((UInt32*)s)++!=code_type || *((UInt32*)s)++!=' ID ')
		return false;

	/* read decimal integer (resource ID) */
	do
	{
		if ((c=*s++-'0')>(UInt8)('9'-'0'))
			{--s; break;}
		code_id = 10*code_id+c;
	} while(s<e);

	if (code_id<=0 || *((UInt16*)s)++!='\047+')
		return false;

	/* read hexadecimal integer (offset into resource) */
	do
	{
		if ((c=*s++-'0')>(UInt8)('9'-'0')
				&& (UInt8)((c+='0'-'A'+10)-10)>(UInt8)('F'-'A')
				&& (UInt8)((c+='A'-'a')-10)>(UInt8)('f'-'a'))
			{--s; break;}
		code_offset = ((unsigned)code_offset<<4)+c;
	} while(s<e);

	if (code_offset<=0)
		return false;

	/* get an adequate buffer for one giant module */
	if (temp_code_read_buffer==NULL)
		if ((temp_code_read_buffer=NewPtr(SINGLE_MODULE_MAXIMUM_SIZE))==NULL)
			return false;

	if (!read_code_resource(temp_code_read_buffer,code_id,code_offset,SINGLE_MODULE_MAXIMUM_SIZE))
		return false;
	/* follow branch islands to get the real name */
	if (*(UInt16*)temp_code_read_buffer==0x60FF)
	{
		code_offset += *(SInt32*)(2+temp_code_read_buffer)+2;
		if (!read_code_resource(temp_code_read_buffer,code_id,code_offset,SINGLE_MODULE_MAXIMUM_SIZE))
			return false;
	}

	if (scan_to_next_module(temp_code_read_buffer,
			SINGLE_MODULE_MAXIMUM_SIZE+temp_code_read_buffer,&next_module,out_string,true)==NULL
			|| out_string[0]==0)
		return false;
	if (out_string[0]>240)
		return true;
	if (out_string[1]==',')
		*(UInt32*)out_string = '\007ano',
			*(UInt32*)(4+out_string) = 'ncrf';
	/*else if (out_string[1]=='')
	{ // branch island -- must do another round
	}*/
	out_string[1+out_string[0]] = '(';
	out_string[0] += 2+make_base_string(2+out_string[0]+out_string,basechars,++counter,10,0);
	out_string[out_string[0]] = ')';

	return true;
}

/* returns addition to clip size */
/* as for maximum_length, negative values are code for specific pointer types:
   -1 for Ptr, -2 for Handle (dereferenced), -3 for realloc */
static int local_insert_texts(void *text, /* function does nothing if NULL */
	long text_length, /* can be <0 (retrieves length from text - except realloc) */
	long clip_start,
	long clip_end,
	long maximum_length, /* >0, text is a fixed-string pointer; zero cancels */
	const void *insertion_text, /* can be NULL */
	long insertion_length,
	const UInt8 *trailer) /* can be NULL */
{
	Handle			h = NULL;
	int				clipped_length, trailer_length = trailer==NULL ? 0:trailer[0];
	int				addition_to_size, clip_size;
	const UInt8		*s;
	UInt8			*d;

	/* check pointers and lengths */
	if ((d=(UInt8*)text)==NULL || maximum_length==0)
		return 0;
	if ((s=(UInt8*)insertion_text)==NULL || insertion_length<=0)
		insertion_length = 0;

	if ((UInt8)maximum_length==0xFE && (h=RecoverHandle(text))==NULL)
		{DebugStr("\plocal_insert_texts: RecoverHandle failed to produce handle."); return -1;}

	/* check starting offset in text */
	if (clip_start<=0)
		clip_start = 0;
	else if (clip_start>(unsigned)maximum_length)
		return 0;

	/* check ending offset in text -- unsigned so length code -> MacOS maximum */
	if ((unsigned)clip_end<clip_start)
		clip_end = clip_start;
	else if ((unsigned)clip_end>maximum_length)
		clip_end = maximum_length<0 ? 0x7FFFFFF0L:maximum_length;

	/* sum up lengths */
	if (text_length<0)
		switch(maximum_length&0xFF)
		{
		case 0x00: text_length = 0; break;
		case 0xFF: text_length = GetPtrSize(text); break;
		case 0xFE: text_length = GetHandleSize(h); break;
		case 0xFD: DebugStr("\plocal_insert_texts: realloc code doesnt support 'get length'."); return -1;

		default: goto invalid;
		}

	if ((clip_size=clip_end-clip_start)>text_length) /* should not go out of range! */
		text_length = clip_size; /* tricky restoration (Debugger here?) */
	insertion_length += trailer_length;

	if (maximum_length>=0)
	{ /* clip length */
		if ((clipped_length=maximum_length+clip_size-text_length)<insertion_length)
			maximum_length = 0x8000; /* maximum length is useless now; its now a flag */
		else
			maximum_length = 0, clipped_length = insertion_length;
	} else if ((clipped_length=0x7FFFFFF0L-clip_size)<insertion_length)
		maximum_length &= 0x80FF; /* lower byte is still used */
	else
		maximum_length &= 0x00FF, clipped_length = insertion_length;

	addition_to_size = clipped_length-clip_size;
	/* handle resizing */
	switch(maximum_length&0xFF)
	{
	case 0xFF:
		SetPtrSize(text,addition_to_size+text_length);
		goto mac_error;
	case 0xFE:
		SetHandleSize(h,addition_to_size+text_length);
		d = (UInt8*)*h; /* text is now stale, but its only used once (placed into d) */
	mac_error:
		if (MemError()!=noErr)
			goto signal_error;
		goto resize_error;
	case 0xFD:
#ifdef __STDLIB__
		d = realloc(d,addition_to_size+text_length);
#else
		DebugStr("\plocal_insert_texts: realloc not supported (stdlib.h not included).");
#endif
	resize_error:
		if (d==NULL) /* MemError is unrealiable in this context */
			{signal_error: DebugStr("\plocal_insert_texts: resizing error."); return -1;}
	case 0x00:
		break;

	default:
	invalid:
		DebugStr("\plocal_insert_texts: unrecognized length code.");
		return -1;
	}

	/* move endmost text */
	/* (I inadvertently left the trailer length adding twice the last time) */
	BlockMoveData(clip_end+d,addition_to_size+clip_end+d,text_length-clip_end);

	/* return clipped length to label length */
	if ((clipped_length-=trailer_length)<=0)
		return 0; /* crap - filled to capacity (when adding the trailer) */

	/* copy label */
	d += clip_start;
	if (clipped_length&1)
		*d++ = *s++;
	if (clipped_length&2)
		*((UInt16*)d)++ = *((UInt16*)s)++;
	if (clipped_length&4)
		*((UInt32*)d)++ = *((UInt32*)s)++;
	if ((clipped_length&=-8)!=0)
		do{*((UInt32*)d)++ = *((UInt32*)s)++; *((UInt32*)d)++ = *((UInt32*)s)++;} while((clipped_length+=-8)!=0);

	if ((maximum_length&0x8000)!=0) /* clipped flag signaled */
		d[-1] = ''; /* replace last char in print with elipsis */

	if (trailer!=NULL)
	{ /* copy trailer (probably a displacement) */
		s = 1+trailer;
		if (trailer_length&1)
			*d++ = *s++;
		if (trailer_length&2)
			*((UInt16*)d)++ = *((UInt16*)s)++;
		if (trailer_length&4)
			*((UInt32*)d)++ = *((UInt32*)s)++;
		if ((trailer_length&=-8)!=0)
			do{*((UInt32*)d)++ = *((UInt32*)s)++; *((UInt32*)d)++ = *((UInt32*)s)++;} while((trailer_length+=-8)!=0);
	}

	return addition_to_size;
}

static void make_code_id_string(UInt8 *out_string,
	const char *basechars,
	OSType restype,
	int code_id,
	long offset)
{
	int				length = 11;

	if (code_id<0) /* finally made silenced IDs functional; 2008.04.19 01:20 GMT */
		code_id = -code_id;
	*(UInt32*)out_string = '\013; \047',
		*(UInt32*)(4+out_string) = restype,
		*(UInt32*)(8+out_string) = ' ID ';
	length += make_base_string(length+1+out_string,basechars,code_id,10,0);
	out_string[++length] = '\047';
	out_string[++length] = '+';
	length += make_base_string(length+1+out_string,basechars,offset,16,6);
	out_string[0] = length;
}

/*
  format of jump-table:
   CODE_ID.32, offset.32
*/
static Boolean make_address_string(UInt8 *out_string,
	const char *basechars,
	OSType restype,
	Ptr instruction,
	SInt32 *jump_table,
	SInt32 jump_count)
{
	SInt32			*entry = NULL, displacement = 0;
	SInt16			*literal = 1+(SInt16*)instruction;

	if (jump_table==NULL)
		return false;
	if (*(UInt16*)instruction==0x4EAD /* JSR xxxx(A5) */
			|| *(UInt16*)instruction==0x486D /* PEA xxxx(A5) */
			/*|| *(UInt16*)instruction==0x4878 // PEA xxxx -- more likely a literal */
			|| *(UInt16*)instruction==0x4879 /* PEA xxxxxxxx -- only probably */
			|| (*(UInt16*)instruction&0xF1FF)==0x41ED) /* LEA xxxx(A5) */
		displacement = *literal;/*, probably = true;*/
	/*else if (*(UInt16*)instruction==0x4EB8) // JSR $xxxx -- only possibly
		displacement = *literal;*/
	else if (*(UInt16*)instruction==0x4EB9) /* JSR $xxxxxxxx -- format isnt definite */
		displacement = *(SInt32*)literal;/*, probably = true;*/
	else
		return false;

	if ((displacement&7)!=2) /* sub-offset check */
		return false;
	/* range check */
	if ((unsigned)(displacement=displacement-0x22>>2)<jump_count*2)
	{
		/* verify validity in entry in custom setup first */
		entry = displacement+jump_table;
		if (entry[0]==INT_UNDEF || entry[1]<0) /*(entry[0]|entry[1])==-1*/
		{
			/**(UInt32*)out_string = '\007INV',
				*(UInt32*)(4+out_string) = 'ALID';*/
			return false;
		}

		/*out_string[0] = sprintf(1+(char*)out_string,"; 'CODE ID %d'+%06X", entry[0],entry[1]);*/
		make_code_id_string(out_string,basechars,restype,entry[0],entry[1]);
	}

	return true;
}

/* does not affect output string if no coderef is found */
/* function added after crf_modules implementation (used temporary); 2008.04.15 23:50 GMT */
static void get_any_code_offset_module(UInt8 *l,
	const char *bc,
	UInt8 *n,
	int x,
	long o)
{
	UInt8			t[64], *p;
	int				z;

	make_code_id_string(t,bc,code_type,x,o);
	if ((p=get_offset_label_str(l,(long)0x80000000
			|~calculate_crc32(t+3,t[0]-2,-1),true,
			_module_code_type))!=NULL && (z=*p-5)>0)
		memcpy(n+1,p+6,n[0]=z);
}

static void insert_operand_labels(UInt8 *l,
	const char *bc,
	UInt8 *a,
	UInt8 *b,
	UInt8 *c,
	int x,
	Boolean n) /* added; 2008.06.19 01:40 GMT */
{
	UInt8			buf[64];

	/* temporary pointers, string pointer, string end, type */
	UInt8			*t, *t2, *s, *e, y;
	long			o = 0, d, z, z2; /* offset for label, displacement, data sizes */
	int				i; /* temporary integer */

	/* prep displacement texts */
	*(UInt32*)buf = '\0\0$\0';

	if (c[0]<127)
		c[1+c[0]] = 0;
	if (c[0]==10)
	{ /* label (maybe) */
		*(UInt16*)(1+c) = '0x';
		o = read_any_integer(1+(char*)c);
		*(UInt16*)(1+c) = '; ';
	} else if (c[0]>2)
		o = (long)0x80000000|~calculate_crc32(3+c,c[0]-2,-1);

	/* load up! */
	i = *b++, e = i+b, s = b;
	if (o==0)
	{ /* zref cache (to prevent scanning large lists for little reason) */
		static UInt8	*zlis = NULL, *zref = (UInt8*)-1;
		static UInt32	zcnt = 0;

		if (zlis!=l || zcnt!=*(UInt32*)l || zref==(UInt8*)-1)
			zlis = l, zcnt = *(UInt32*)l, zref = get_offset_label_str(l,o,true,_module_code_type);
		t = zref;
	} else
	{ /* search code refs for module name; 2008.04.15 23:41 GMT */
		if ((t=get_offset_label_str(l,o,false,_module_code_type))==NULL && x>0
				&& a!=NULL && (*(UInt32*)a=='\003BSR' || *(UInt32*)a=='\003JSR'))
			{get_any_code_offset_module(l,bc,b-1,x,o); return;}
	}
	if (t==NULL || (z=*t++-5)<=0)
		z = 0, o = 0, y = _module_coderef_type; /* default (least processing) */
	else
	{
		y = *t++; /* allow for datarefs either way */
		/* handle displacement text; keep as short as possible (minlength=0) */
		if ((d=o-*((SInt32*)t)++)==0)
			buf[0] = 0;
		else
		{
			if (d>=0)
				buf[1] = '+';
			else
				buf[1] = '-', d = -d;
			buf[0] = 2+make_base_string(3+buf,bc,d,16,0);
		}
		/* clip length (unnecessary)
		if ((z+=buf[0])>255)
			z = 255;
		z -= buf[0];*/
	}
next:
	if (s>=e)
		return; /* nothing to change */
	/* replace the PC-relative offset or A5 displacement with the label name */
	do
	{
		/* parsed char, previous pointer */
		UInt8		c, *p;

		if ((c=*s++-'*')==0)
		{ /* displacement from PC; if label is for a coderef, absorb it */
			p = s-1;
			/* pass displacement */
			if ((c=*s++-'-')!=0 && (c+='-'-'+')!=0 || s>=e)
				return;
			/* pass hex */
			if ((c=*s++-'$')!=0 || s>=e)
				return;
			if (y>=_module_coderef_type)
				continue; /* datarefs are no good either */
			/* skip hex */
			do
			{
				if (s>=e)
					{++s; break;}
			} while((c=*s++-'0')<=(UInt8)('9'-'0') || (c+='0'-'A')<=(UInt8)('Z'-'A')
					|| (c+='A'-'a')<=(UInt8)('z'-'a'));
			--s;

			e = (b[-1]+=i=local_insert_texts(b,b[-1],p-b,s-b,255,t,z,buf))+b;
			s += i;
		} else if ((c+='*'-'$')==0)
		{ /* hex number */
			UInt32		v2 = 0;
			Boolean		m = false; /* negative displacement */

			p = s-1;
			/* standard coderefs are always positive, but allow for datarefs */
			if (s[-2]=='-' && s-b>1)
				m = true, --p; /* include the hyphen char (negative displacement) */
			/*else if (y>=_module_data_type) // commented out; 2008.06.19 02:21 GMT
				continue; // standard datarefs are always negative */
			if (s>=e)
				return;
			/* parse hex (pass for coderefs, process for datarefs) */
			do
			{
				if ((c=*s++-'0')>(UInt8)('9'-'0')
						&& (UInt8)((c+='0'-'A'+10)-10)>(UInt8)('F'-'A')
						&& (UInt8)((c+='A'-'a')-10)>(UInt8)('f'-'a'))
				{
					--s;
					if (s-p>7) /* 2008.06.19 02:59 GMT */
						break;
					/* not absolute, pass (a5)|(A5) */
					if (e-s>3 && *s=='(')
					{
						if (((c=*++s+-'A')!=0 && c!=(UInt8)('a'-'A') || s[1]!='5' || s[2]!=')'))
							goto next;
						s += 3;
					} else
						goto next;
					break;
				}
				v2 = (v2<<4)+c;
			} while(s<e);

			if (s-p<=4) /* should be an A5 reference or 32 bit absolute */
				continue;

			/* ModifyOperand doesnt always show absolutes with sign; 2007.12.14 07:35 GMT */
			if ((v2&(long)0x80000000)!=0)
				v2 = -(signed)v2, m = !m;
			else if ((unsigned)(s-p-4)<=1 && (v2&0x8000)!=0 && !m)
				v2 = -(SInt16)v2, m = true; /* 16 bit displacement for same case; 2008.04.16 02:35 GMT, 2008.06.19 03:21 GMT */

			if (m)
			{
				if ((t2=get_offset_label_str(l,-v2,false,_module_data_type))==NULL
						|| (z2=*t2-5)<=0)
				{ /* added; 2008.06.19 01:43 GMT */
					/*static untitled_dref_count = 0;*/

					if (!n)
						continue;
					/*z2 = 4, t2 = (UInt8*)"drf";*/
					/*buf[32] = make_base_string(33+buf,bc,++untitled_dref_count,16,0);*/
					z2 = 1, t2 = (UInt8*)""; /* reprint without visible sign; 2008.06.19 03:36 GMT */
					buf[32] = make_base_string(33+buf,bc,(UInt32)-v2,16,0);
				} else
				{
					t2 += 6, buf[34] = '$';
					if ((v2=-((SInt32*)t2)[-1]-v2)==0) /* corrected (again); 2008.04.19 20:40 GMT */
						buf[32] = 0;
					else
					{ /* added (signed) and displacement error; 2008.04.15 21:39 GMT */
						if ((signed)v2>=0)
							buf[33] = '+';
						else if ((signed)v2>=-DISPLACEMENT_ERROR)
							buf[33] = '-', v2 = -v2;
						else
							continue;
						buf[32] = 2+make_base_string(35+buf,bc,v2,16,0);
					}
				}
				e = (b[-1]+=i=local_insert_texts(b,b[-1],p-b,s-b,255,t2,z2,32+buf))+b;
			} else
				e = (b[-1]+=i=local_insert_texts(b,b[-1],p-b,s-b,255,t,z,buf))+b;
			s += i;
		} else if ((c+='$'-'#')==0)
			s += 2; /* literal (skip) */
	} while(s<e);
}

/* added 2007.12.10 16:13 GMT */
/* returns false if a label has already been made for the offset */
Boolean add_offset_label(long offset)
{
	long			*t, x;
	OSErr			err;

	if (stored_offset_count<0)
		return false;
	if ((x=stored_offset_count)>0 && stored_offsets!=NULL && (t=*stored_offsets)!=NULL)
		do
		{
			if (*t++==offset)
				return false;
		} while(--x!=0);

	if (stored_offsets==NULL)
	{
		stored_offsets = (long**)NewHandle(sizeof(offset));
		err = MemError();
	} else
		err = PtrAndHand(&offset,(Handle)stored_offsets,sizeof(offset));
	if (err!=noErr)
	{
		fprintf(stderr,"### add_offset_label: could not expand offset list (%d)", err);
		stored_offset_count = -1;
		return false;
	}

	++stored_offset_count;

	return true;
}

/* added; 2007.12.16 06:25 GMT
static Boolean remove_offset_label(long offset)
{
	long			*t, x, c = -1, z;
	Boolean			r = false; // has resized

	if (stored_offset_count<0)
		return false;
	if ((x=stored_offset_count)>0 && stored_offsets!=NULL && (t=*stored_offsets)!=NULL)
	{
		c = x;
		if ((z=InlineGetHandleSize((Handle)stored_offsets))<=0 || z!=sizeof(long)*c)
		{
			DebugStr("remove_offset_label: offset count>0, but handle size is invalid");
			return false;
		}
		do
		{
			if (*t++==offset)
				{r = true, --c; BlockMove(t,t-1,sizeof(long)*(x-1));}
		} while(--x!=0);
	}

	if (r && c>=0)
		SetHandleSize((Handle)stored_offsets,sizeof(long)*c);
}*/

static Boolean make_segment_relocation_strings(Ptr code,
	Ptr instruction,
	const char *name,
	int name_length,
	UInt8 *operands,
	UInt8 *comment,
	const char *basechars)
{
	SInt32			offset = 0;
	UInt16			opword_y = *((UInt16*)instruction)++;

	if ((opword_y+=-0x4EB9)!=0 && (opword_y+=0x4EB9-0x4879)!=0
			 && (opword_y=(opword_y+0x4879-0x41F9)&0xF8FF)!=0)
		return false;

	if (name==NULL || name_length<=0)
		name_length = 0;
	else
		name_length += 2;

	offset = EXT_SEGMENT_HEADER_SIZE+*(SInt32*)instruction;
	*(UInt16*)(1+comment) = '; ';
	comment[0] = 2+make_base_string(3+comment,basechars,offset,16,8);

	*(UInt32*)operands = '\003*+$';
	if ((offset-=instruction-code)<0)
		operands[2] = '-', offset = -offset;
	operands[0] += make_base_string(4+operands,basechars,offset,16,0);

	/* clip length */
	if ((name_length+=operands[0])>255)
		name_length = 255;
	if ((name_length-=operands[0])>2)
	{
		char		*d = 1+operands[0]+(char*)operands;

		operands[0] += name_length;
		*d++ = '(';
		if ((name_length-=2)&1)
			*d++ = *name++;
		if (name_length&2)
			*((UInt16*)d)++ = *((UInt16*)name)++;
		if (name_length&4)
			*((UInt32*)d)++ = *((UInt32*)name)++;
		if ((name_length&=-8)!=0)
			do{*((UInt32*)d)++ = *((UInt32*)name)++; *((UInt32*)d)++ = *((UInt32*)name)++;}while((name_length+=-8)!=0);
		*d = ')';
	}

	return true;
}

/* added 2007.12.10 15:06 GMT */
static void make_label_string(UInt8 *out_string,
	UInt8 *operands,
	UInt8 *comment,
	const char *basechars,
	Boolean no_coderef_names,
	long module_end,
	long trailer_size,
	long instruction_offset,
	int instruction_size,
	char label_char)
{
	long			offset = 0;

	comment[1+comment[0]] = 0; /* null terminate (temporary can hold any possible outcome here) */
	/*if (sscanf(1+(char*)comment,"; %X", &offset)==1)*/
	if (comment[0]==10)
	{ /* label (maybe) */
		*(UInt16*)(1+comment) = '0x';/* destructively change the text to read as hex */
		offset = read_any_integer(1+(char*)comment);
		*(UInt16*)(1+comment) = '; ';
		if (offset<=0 || (offset&1)!=0) /* exclude odds and negatives (especially since coderefs are stored as negatives) */
			return;
		if (instruction_offset>=0 && (unsigned)(offset-instruction_offset-1)<instruction_size-1)
			return; /* in the middle of the current instruction!; 2007.12.16 06:41 GMT */
		if (module_end>=0 && trailer_size>0 /*&& ((offset-module_end)&3)!=0*/
				&& (unsigned)(offset-module_end-1)<trailer_size-1)
			return; /* within module trailer; 2007.12.16 11:08 GMT */
		/* try to find the offset in the list to reduce redundant inclusions; add to the list if not found */
		if (!add_offset_label(offset))
			return;
		out_string[0] = 1+make_base_string(2+out_string,basechars,++label_counter,36,5);
		out_string[1] = label_char;
		operands[0] = 0;
		return;
	} else if (comment[0]<=2)
		return;

	/* code reference (stored as a negative in the list) */
	/*if (!add_offset(offset=~code_ref_counter))*/
	if (!add_offset_label((long)0x80000000|~calculate_crc32(3+comment,comment[0]-2,-1)))
		return;
	/*out_string[0] = sprintf(1+(char*)out_string,"coderef%u", ++code_ref_counter);*/

	/* try to find a module name */
	++code_ref_counter; /* considering that it is a coderef, count anyway */
	if (no_coderef_names || !comment_to_module_name(out_string,comment,basechars))
	{
		*(UInt32*)out_string = '\007cod';
		*(UInt32*)(4+out_string) = 'eref';
		out_string[0] = 7+make_base_string(8+out_string,basechars,code_ref_counter,10,0);
	}
}

static int single_opword(UInt16 opword,
	void *next,
	void *base,
	void *module,
	Boolean upper,
	UInt8 *labels)
{
	UInt8			*t;
	const char		*str = NULL, *aspstr;
	int				next_word;
	short			x;

	/* blah; 2008.05.30 13:09 */
	switch(tab_width)
	{
	case 1: aspstr = "\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t"; break;
	case 2: aspstr = "\t\t\t\t\t\t\t"; break;
	case 3: aspstr = "\t\t\t\t\t"; break;
	case 4: aspstr = "\t\t\t\t"; break;
	case 5: case 6: aspstr = "\t\t\t"; break;
	case 7: case 8: aspstr = "\t\t"; break;

	default: aspstr = "\t";
	}

	if ((opword+=-0x4E74)==0)
		str = upper ? "\tRTD%s#$%04X\n":"\trtd%s#$%04X\n";
	else if ((opword+=0x4E74-0x4E75)==0)
		str = upper ? "\tRTS\n":"\trts\n", opword = -1;
	else if ((opword+=0x4E75-0x4ED0)==0)
		str = upper ? "\tJMP%s(A0)\n":"\tjmp%s(a0)\n", opword = -1;
	if (next==NULL)
		next_word = -1, module = NULL;
	else
	{
		next_word = *(UInt16*)next;
		if (base!=NULL && (t=get_offset_label_str(labels,(Ptr)next-2-(Ptr)base,true,
				_module_code_type))!=NULL && (x=*t-5)>0 && t[6]!=(UInt8)'\247')
		{
			fwrite(6+t,1,x,stdout);
			fputc(':',stdout);
			fputc('\n',stdout);
		}
	}

	if (str==NULL)
		return 0;
	if (module!=NULL)
		print_local_offset((UInt8*)next-(UInt8*)module+-2);
	else if ((unsigned)(tab_width-1)>1)
		fputc('\t',stdout);
	else
		fputs(tab_width==1 ? "\t\t\t\t":"\t\t",stdout);
	printf(str, aspstr,next_word);

	return opword==(UInt16)-1 ? 2:4;
}

static Ptr scan_to_next_local_coderef(UInt8 *l, Ptr c, Ptr s, char *e, int x)
{
	if (e>s+32766) /* clip data length (for performance and rediculousness reasons) */
		e = s+32766;
	while(s<e)
	{
		if (*(UInt16*)s==0x4E56 && ((SInt16*)s)[1]<=0) /* valid A6 Link */
			break;
		temporary[0] = 0;
		get_any_code_offset_module(l,(char*)temporary,temporary,x,s-c); /* slow way */
		if (temporary[0]!=0)
			break;
		s += 2;
	}

	return s;
}

/* fixed the method for looking for link a6, #0b1xxxxxx0|0b00000000; 2007.12.14 03:53 GMT */
/* added printable_ascii; 2008.04.16 1AM EDST */
static void *pass_text(void *data, void *code_end, Boolean printable_ascii)
{
	UInt8			*s = data, *e = code_end, c;

	if (printable_ascii)
		while(s<e && (*(SInt16*)s>0 || (*(UInt32*)(s-2)&0xFFFF0001)!=0x4E560000))
		{
			if ((c=*s++)!=0 && (c+=-'\t')!=0 && (c+='\t'-'\r')!=0 && (c+='\r'-'\n')!=0
					&& (c+='\n'-' ')>94) /* outside [' ',fwd del) */
				return --s;
			if (*(SInt16*)s<=0 && (*(UInt32*)(s-2)&0xFFFF0001)==0x4E560000)
				return s;
			if ((c=*s++)!=0 && (c+=-'\t')!=0 && (c+='\t'-'\r')!=0 && (c+='\r'-'\n')!=0
					&& (c+='\n'-' ')>94)
				return --s;
		}
	else
		while(s<e && (*(SInt16*)s>0 || (*(UInt32*)(s-2)&0xFFFF0001)!=0x4E560000))
		{
			if ((c=*s++)!=0 && (c+=-'#')!=0 && (c+='#'-'%')!=0 && (c+='%'-'.')!=0
					&& (c+='.'-'0')>(UInt8)('9'-'0') && (c+='0'-'A')>'Z'-'A'
					&& (c+='A'-'_')!=0 && (c+='_'-'a')>'z'-'a')
				{--s; break;}
			if ((*(SInt16*)s<=0 && (*(UInt32*)(s-2)&0xFFFF0001)==0x4E560000)
					|| ((c=*s++)!=0 && (c+=-'#')!=0 && (c+='#'-'%')!=0 && (c+='%'-'.')!=0
					&& (c+='.'-'0')>(UInt8)('9'-'0') && (c+='0'-'A')>'Z'-'A'
					&& (c+='A'-'_')!=0 && (c+='_'-'a')>'z'-'a'))
				break;
		}

	return s;
}

enum
{ /* option_flags */
	_force_lowercase		= 0x01, /* force lowercase instruction lines */
	_coderef_names			= 0x02, /* use/make coderefs */
	_process_cases			= 0x04, /* make case label for each case entry */
	_coderef_modules		= 0x08, /* scan coderefs to make module names */
	_module_offsets			= 0x10, /* for each instruction, print module offset */
	_print_headings			= 0x20, /* otherwise, avoid headings altogether */
	_avoid_nested_comments	= 0x40, /* no Printing Disassembly... */
	_no_negative_absolutes	= 0x80, /* dont simply print negative absolutes */
	_no_on_line_comments	= 0x100 /* dont print the comment ("; ...") */
};

/* formerly disassemble_code */
/* elongated operand parameter (256+temporary -> 384+temporary); 2007.12.12 GMT
  and this meant increasing the size of temporary to at least 768 bytes */
/* moved to segment shell due to code overflow; 2007.12.18 07:59 GMT */
static void do_code(Ptr code,
	long offset_to_start,
	long offset_to_end, /* added (was only termination); 2008.05.22 03:36 GMT */
	long termination,
	long data_reloc,
	long code_reloc,
	int code_id, /* (pass non-positive value to nix _coderef_modules) */
	SInt32 *jump_table,
	SInt32 jump_count,
	const char *only_module,
	UInt32 option_flags,
	int function,
	UInt8 *label_list)
{
	static Str255	current_module_name;

	const char		*mb_str;
	Ptr				instruction = offset_to_start+code, code_end = offset_to_end+code;
	Ptr				code_term = termination+code;
	Ptr				module_end = NULL, module_start = NULL;
	Ptr				previous_instruction = NULL, first_end, last_compare = NULL;
	Ptr				previous_instruction2 = NULL;
	void			*next_module = NULL;
	long			size, om_size = only_module==NULL ? -1:strlen(only_module);
	UInt32			first_reloc;
	int				next_table_size = -1, module_return_count = 0, next_table_xsize = 0;
	UInt16			opword_x = 0;
	short			bytes_used = 0, line_offset = 0; /* line_offset was an int */
	Boolean			has_disassembled = option_flags&_avoid_nested_comments;
	Boolean			module_advance = false;

	/* added; 2008.05.30 13:24 GMT */
	switch((tab_width<<1)|(option_flags&_force_lowercase)) /* should equate to |(x&1) */
	{ /* order corrected; 2008.06.18 20:37:36 GMT */
	case 2: mb_str = "\t\t\t\tDC.B\t\t\t\t\t\t\t\t\t\t\t\t%P\n"; break;
	case 3: mb_str = "\t\t\t\tdc.b\t\t\t\t\t\t\t\t\t\t\t\t%P\n"; break;
	case 4: mb_str = "\t\tDC.B\t\t\t\t\t\t%P\n"; break;
	case 5: mb_str = "\t\tdc.b\t\t\t\t\t\t%P\n"; break;
	case 6: mb_str = "\tDC.B\t\t\t\t%P\n"; break;
	case 7: mb_str = "\tdc.b\t\t\t\t%P\n"; break;
	case 8: mb_str = "\tDC.B\t\t\t%P\n"; break;
	case 9: mb_str = "\tdc.b\t\t\t%P\n"; break;
	case 10: case 13: mb_str = "\tDC.B\t\t%P\n"; break;
	case 11: case 12: mb_str = "\tdc.b\t\t%P\n"; break;

	default: mb_str = (option_flags&_force_lowercase)!=0 ? "\tdc.b\t%P\n":"\tDC.B\t%P\n";
	}

	if (code_id<=0)
		option_flags &= ~_coderef_modules;
	if ((unsigned)termination<=1)
		has_disassembled = true; /* to silence the stupid message; 2008.04.18 23:29 GMT */

	current_module_name[0] = 0;
	if (data_reloc<=0 || data_reloc>termination)
		data_reloc = -1;
	if (code_reloc<=0 || code_reloc>termination)
		code_reloc = -1;
	if (*(SInt32*)instruction==0)
	{
		if (function==0)
			puts("; Four zero bytes:\t0000 0000");
		instruction += 4;
		if (*(OSType*)instruction=='CHEZ')
		{
			if (function==0)
				printf(";\t....signature:\t'%-4.4s'\n", instruction);
			instruction += 4;
		}
		fflush(stdout);
	}

	if ((unsigned)data_reloc<(unsigned)code_reloc)
		first_reloc = data_reloc;
	else
		first_reloc = code_reloc;
	if ((unsigned)termination<(unsigned)first_reloc)
		first_end = code_term;
	else
		first_end = first_reloc+code;

	module_start = (option_flags&_module_offsets) ? instruction:NULL;

	do
	{
		Ptr			t;
		UInt32		result_code;
		Boolean		operand_labels = true;

	/*	if (instruction-code==0x46E0)
			Debugger();*/
		if ((1&(int)next_module)!=0 && module_end!=NULL && instruction>=module_end)
		{ /* a symbol that didnt work too well gets printed as data only */
			++((Ptr)next_module), opword_x = *((UInt16*)instruction)++;
			if (function==0)
				if (single_opword(opword_x,instruction,code,module_start,
						(option_flags&_force_lowercase)==0,label_list)>0)
					++module_return_count;
			next_module = pass_text(next_module,code_end,false);
			if (function==0)
			{
				print_trailer(instruction,code_term,module_start,(Ptr)next_module-instruction,
					instruction-code,(option_flags&_force_lowercase)==0,true);
				if (user_abort)
					return;
			}

			previous_instruction2 = previous_instruction = NULL;
			instruction = next_module;
			module_start = (option_flags&_module_offsets) ? instruction:NULL;
		}
		if (*(UInt32*)instruction==0x00004E56 /* zero word and link; 2008.04.18 22:30 GMT */
				|| *(UInt32*)instruction==0x000048E7) /* MOVEM ...,-(A7); 2008.04.20 00:09 GMT */
		{ /* at the very least, 0x00004E56 would be ORI.B with high byte  zero */
			print_trailer(instruction,code_term,module_start,bytes_used=2,
				instruction-code,(option_flags&_force_lowercase)==0,false);
			continue;
		}
		if (instruction>=(Ptr)next_module) /* NULL should count */
		{
			Boolean		pending_name_write = false;

			/* added; 2007.12.14 01:32 GMT */
			if (!has_disassembled && function==0)
				puts("\n; Printing Disassembly..."), has_disassembled = true;

			if (next_module==NULL)
				next_module = instruction;
			current_module_name[0] = 0;
			if ((module_end=scan_to_next_module(instruction,code_end,&next_module,current_module_name,false))==NULL)
				current_module_name[0] = 0;
			if (current_module_name[0]==0 && function<=0)
			{
				if (instruction<code_end)
					puts("; (no module name)");/*puts("; Trailer Data (cant decompile from here)");*/
				break;
			}

			if (*(SInt16*)next_module<=0 && (*(UInt32*)((Ptr)next_module-2)&0xFFFF0001)==0x4E560000)
				next_module = -2+(Ptr)next_module; /* adjust... */

			/* crf_modules option added 2008.04.15 18:19 GMT */
			/* moved here (from fail only); 2008.04.16 00:55 GMT */
			if ((option_flags&_coderef_modules) && function==0)
				get_any_code_offset_module(label_list,ubasechars,current_module_name,
					code_id,instruction-code);
			if (function<=0)
				if (*(UInt16*)current_module_name=='\001,') /* (unnamed) */
					pending_name_write = true;
				else if (*(UInt16*)current_module_name=='\001') /* branch island */
					printf(function==0 ? "; Branch Island %u":"BI%u", ++branch_island_count);
				else
				{
				print_module_name:
					if (om_size>0 && (current_module_name[0]!=om_size
							|| memcmp(1+current_module_name,only_module,om_size)!=0))
					{
						previous_instruction2 = previous_instruction = NULL;
						instruction = next_module;
						module_start = (option_flags&_module_offsets) ? instruction:NULL;
						continue;
					}
					if (function==0)
						fputs("; ",stdout);
					if (*(UInt32*)(current_module_name[0]-2+current_module_name)=='(?)\0' || function<0)
						fwrite(1+current_module_name,current_module_name[0],1,stdout);
					else
						pending_name_write = true;
				}

			if (instruction-code>1 && *(SInt16*)instruction<=0
					&& (*(UInt32*)(instruction-2)&0xFFFF0001)==0x4E560000)
				instruction += -2; /* adjust....; 2007.12.14 02:30, 04:40 GMT */

			/* addition; 2008.04.16 03:36 GMT */
			if ((option_flags&_coderef_modules) && function==0)
				get_any_code_offset_module(label_list,ubasechars,current_module_name,
					code_id,instruction-code);
			if (pending_name_write) /* oh, fudge; 2008.04.16 03:41 */
			{
				if (*(UInt16*)current_module_name=='\001,')
					printf(function==0 ? "; Anon%u":"unnamed%u", ++anon_count);
				else
					printf((1&(int)next_module) ? "%P(?)":"%P",current_module_name);
			}

			if (function<0)/*|| function==1*/
			{
				if (*(UInt16*)current_module_name=='\001,')
					printf(": %08X\n", instruction-code);
				else
					printf(" %u: %08X\n", ++module_counter,instruction-code);
				add_offset_label(instruction-code);
			} else if (function==0)
				{printf("\n; %08X\n", instruction-code); fflush(stdout);}
			else if (module_advance)
				fputc('\n',stdout);
			module_advance = false;
			module_start = (option_flags&_module_offsets) ? instruction:NULL;
		} else if (module_end!=NULL && instruction+1>=module_end)
		{
			Ptr			next_module_end;
			UInt8		old_v = module_end[2], bdt = false;

			if ((next_module_end=(Ptr)validMacsBugSymbol(module_end+2,code_end,temporary))!=NULL)
			{
				/* name mismatch prompts trailer data dump; 2008.04.16 01:05 GMT */
				if ((option_flags&_coderef_modules) && function==0
						&& memcmp(temporary,current_module_name,current_module_name[0]+1)!=0
						&& module_return_count<=1) /* only on first return; 2008.05.17 01:39 GMT */
				{
					/*module_mismatch = true;*/
					/* scan to next module code, and... dump */
					instruction += single_opword(*(UInt16*)instruction,instruction,code,
						module_start,(option_flags&_force_lowercase)==0,label_list);
					++module_return_count;
					t = scan_to_next_local_coderef(label_list,code,instruction,code_end,code_id);

					print_trailer(instruction,code_term,module_start,bytes_used=t-instruction,
						instruction-code,(option_flags&_force_lowercase)==0,*(UInt16*)previous_instruction!=0x4E75);
					continue;
				}
				module_return_count = 0;
			mbsym_backdoor:
				/* added; 2007.12.14 01:37 GMT */
				if (!has_disassembled && function==0)
					puts("\n; Printing Disassembly..."), has_disassembled = true;
				opword_x = *(UInt16*)instruction;
				if (next_module==NULL || next_module>=code_end)
					next_module = next_module_end;
				showMacsBugSymbol(module_end+=2,code_end,temporary,&bytes_used);
				*module_end = old_v; /* bug fixed!; 2007.12.18 02:34 GMT*/

				if ((*(UInt32*)(1+temporary)=='$80+'
						|| *(UInt32*)(1+temporary)=='$80,') /* redumbdant */
						&& (old_v&0x80)==0)
				{
					temporary[2] = ubasechars[old_v>>4],
						temporary[3] = ubasechars[old_v&15];
					if (*(UInt32*)(1+temporary)=='$80+')
						*(UInt16*)&temporary[6] = '00';
				} else if ((*(UInt32*)(1+temporary)&0xFFFF00FF)=='$8\0+' && temporary[3]!='0')
					temporary[3] = '0'; /* cosmetic fix; 2008.04.19 23:05 GMT */
				if (function==0)
				{
					single_opword(opword_x,2+instruction,code,module_start,
						(option_flags&_force_lowercase)==0,label_list);
					++module_return_count;
					if (module_start!=NULL)
						print_local_offset(2+instruction-module_start);
					else
						fputc('\t',stdout);
					printf(mb_str, temporary);
				}

				if ((t=print_macsbug_trailer(code,module_end,code_term,module_start,label_list,
						function,option_flags&_force_lowercase,bdt,(option_flags&_avoid_nested_comments)==0))!=NULL)
					next_module = t;
				if (user_abort)
					return;
				previous_instruction2 = previous_instruction = NULL;
				instruction = next_module, bytes_used = 0;/*, module_advance = true;*/
				module_start = (option_flags&_module_offsets) ? instruction:NULL;
				continue;
			}

			if ((old_v==0 || (old_v&0x7F)==((UInt8*)module_end)[3])
					&& module_end[3]!=0 && module_end[4]!=0x60 && module_end[5]!=0) /* further verify validity; 2008.04.18 22:25 GMT */
			{
				module_end[2] = 0x80;
				if ((next_module_end=(Ptr)validMacsBugSymbol(module_end+2,code_end,temporary))!=NULL)
					{bdt = true; goto mbsym_backdoor;}
			}
			module_end[2] = old_v;
			module_end = next_module_end;
		} else if (previous_instruction!=NULL && *(UInt16*)previous_instruction==0x4E75
				&& (t=pass_text(instruction+3,code_end,(option_flags&_coderef_modules)!=0))-(Ptr)instruction>7)
		{ /* text entry (sans MacsBug symbol name).... possibly */
			if ((((opword_x=*(UInt16*)instruction)&0xF001)==0
					&& ((UInt8*)t)[-1]==0 || ((UInt8*)(t-=2))[-1]==0)
					|| ((*(UInt32*)(2+(t=(opword_x=*(UInt8*)instruction)+instruction))&0xFFFF0001)==0x4E560000)
					&& ((SInt16*)t)[2]<=0)
			{
				t = (Ptr)(~1&(long int)(1+t)); /* was ~1&(3+t); 2008.04.19 23:13 GMT */
				if (function==0)
				{
					if (!has_disassembled) /* added; 2007.12.14 01:38 GMT */
						puts("\n; Printing Disassembly..."), has_disassembled = true;
					if ((*(UInt32*)(t-2)&0xFFFF0001)==0x4E560000 && *(SInt16*)t<=0)
						t -= 2; /* yuck; 2008.04.16 05:41 GMT */
					print_trailer(instruction,code_term,module_start,bytes_used=t-instruction,
						instruction-code,(option_flags&_force_lowercase)==0,*(UInt16*)previous_instruction!=0x4E75);
					if (user_abort)
						return;
					continue; /* more yuck (bytes_used=t-instruction); 2008.04.16 05:50 */
				}
				previous_instruction2 = previous_instruction = NULL;
				instruction = t;
				module_start = (option_flags&_module_offsets) ? instruction:NULL;
			}
		}
		global_idle_proc();
		if (user_abort || stored_offset_count<0)
			return;

		/* fudge -(long)code */
		result_code = Disassembler(-(long)code,&bytes_used,instruction,temporary,128+temporary,384+temporary,NULL);
		if (bytes_used<=0)
			bytes_used = 2;
		else if (bytes_used>=4 && temporary[0]>4)
		{
			opword_x = *(UInt16*)instruction;
			if ((opword_x+=-0x4C3C)==0 || (opword_x+=0x4C3C-0x4C7C)==0)
			{ /* bug fix for MULx/DIVx (I dont know exactly why this crap is happening) */
				make_base_string(131+temporary,ubasechars,*(UInt32*)(4+instruction),16,8);
			}
		}
		if (temporary[0]==0)
			temporary[4], *(UInt32*)temporary = '????';
		else if ((result_code&dis68k_invalid)==0)
			if ((*(UInt8*)instruction&0xF0)==0xA0)
			{ /* A-Trap */
				make_atrap_strings(previous_instruction,previous_instruction2,
					*(UInt16*)instruction,temporary,128+temporary,384+temporary);
			} else if (*(UInt32*)instruction==0x4EB081E1)
			{ /* direct trap; 2008.06.14 16:15 GMT */
				UInt16		equivalent = ((UInt16*)instruction)[2];

				if ((equivalent&3)==0 && ((equivalent+=-0x0400)<=0x3FC
						|| (equivalent+=0x800*4+0x0400-0xE00)-0x800*4<=0xFFC))
				{
					/* a[] uses b[]; c[] is not written if == b[] */
					make_atrap_strings(previous_instruction,previous_instruction2,
						(equivalent>>2)+0xA000,129+temporary,384+temporary,384+temporary);
					if (*(SInt32*)(129+temporary)=='\004DC.')
					{ /* no trap name; default */
						temporary[384] = 0;
						temporary[128] = sprintf(129+(char*)temporary,"([$%04X])", ((UInt16*)instruction)[2]);
					} else
					{
						if ((temporary[128]=3+temporary[129])<=2)
							temporary[128] = 0xFE;
						else
							*(UInt16*)(127+temporary[128]+temporary) = '])';
						*(UInt16*)(129+temporary) = '([';
					}
				}
			} else if ((unsigned)(*(UInt16*)instruction-0x41ED)>0x4EF9-0x41ED
					|| ((((UInt8*)instruction)[1]-0x6D)&0xFF)>0x8C /* 0x6D-0xF9 */
					|| !make_address_string(384+temporary,ubasechars,code_type,instruction,jump_table,jump_count))
			{
				ModifyOperand(128+temporary);

				if (temporary[0]<127)
					temporary[1+temporary[0]] = 0; /* not really necessary... */

				if (((UInt32*)temporary)[96]=='\005; \047' && ((UInt16*)temporary)[194]=='\177\047')
					temporary[384] = 0;
				/*else if (memcmp(temporary,"\006LINK.W",7)==0)*/
				else if (*(UInt32*)temporary=='\006LIN' && ((UInt32*)temporary)[1]=='K.W\0')
					temporary[0] = 4; /* shortened version; 2007.12.07 13:19 GMT */
				else if (temporary[0]>4 && (*(UInt32*)(3+temporary)=='I.B\0'
						|| *(UInt32*)(4+temporary)=='I.B\0') && instruction[2]!=0) /* added zero byte check; 2007.12.12 00:03 GMT */
				/* xxxI.B -- show as hex (might be disassembled data); 2007.12.10 14:23 GMT */
					temporary[384] = sprintf(385+(char*)temporary,"; %04X %04X", *(UInt16*)instruction,((UInt16*)instruction)[1]);
				else if (((UInt32*)temporary)[96]=='\005; \047' && ((UInt16*)temporary)[194]=='\177\047')
					temporary[384] = 0; /* quiet a stupid little zero-width literal (0x7F) */
			}

		if (function!=0)
		{ /* effectively avoid printing labels on traps this time */
			if (function==1 && temporary[384]>9 && temporary[384+7]!=' '
					&& *(UInt16*)(1+temporary)!='DC' /*&& *(UInt16*)(1+temporary)!='dc'*/
					&& temporary[1]!='_')
			{ /* the approach is taken a little differently since there are... bugs */
				long		end_offset = module_end-code, next_offset;

				temporary[0] = 0;
				if ((next_offset=(Ptr)next_module-code)<end_offset
						&& (next_offset=first_reloc)<end_offset
						&& (next_offset=code_end-code)>=end_offset)
				{ /* module_end is bad (no suprise if this is the last module) */
					void		*dick;

					if ((t=scan_to_next_module(instruction,code_end,&dick,current_module_name,true))!=NULL)
						end_offset = t-code;
				}
				make_label_string(temporary,128+temporary,384+temporary,lbasechars,
					(option_flags&_coderef_names)==0,end_offset,next_offset-end_offset,
					instruction-code,bytes_used,'b');
				if (temporary[0]!=0)
					printf("%P %P%P\n", temporary,128+temporary,384+temporary);
				module_advance = true;
			}
			/* labels in the middle of instructions are useless; 2007.12.16 06:21 GMT */
			/*if (bytes_used>2)
				remove_offset_label(2+instruction-code);*/

			if (next_table_size<=0 || (next_table_size&1)!=0)
				goto jmp_rx;
			if ((option_flags&_process_cases) && function>0 && next_table_xsize>0)
			{
				long		jmp_rx_offset = instruction-code-2, offset;

				do
				{ /* implementation for 32 bit offsets (far code); 2008.06.18 17:41 GMT */
					if (next_table_xsize==4)
					{
						if (!add_offset_label(offset=jmp_rx_offset+*((SInt32*)instruction)++))
							continue;
					} else if (!add_offset_label(offset=jmp_rx_offset+*((SInt16*)instruction)++))
							continue;
					/*printf("c%04u ; %08X\n", ++case_count,offset);*/
					temporary[1] = 'c';
					temporary[0] = 5+make_base_string(2+temporary,lbasechars,++case_count,36,5);
					*(UInt32*)(temporary[0]-3+temporary) = ' ; x';
					temporary[0] += make_base_string(temporary[0]+temporary,ubasechars,offset,16,8);
					temporary[temporary[0]] = '\n';
					fwrite(1+temporary,temporary[0],1,stdout);
				} while((next_table_size-=next_table_xsize)!=0);
			}
			previous_instruction2 = previous_instruction = NULL, bytes_used = 0;
			next_table_size = -1;
			goto jmp_rx;
		}

		if (option_flags&_force_lowercase)
		{ /* option for forcing lowercase; 2007.12.10 13:30 GMT */
			if (temporary[1]!='_') /* dont lower trap names */
				LowercaseText(1+(Ptr)temporary,temporary[0],0);
			lower_operands(129+temporary,temporary[128]);
		}

		/* notefy disassembly; 2007.12.13 21:46 GMT */
		if (!has_disassembled)
			puts("\n; Printing Disassembly..."), has_disassembled = true;

		/* get a label for the instruction; if there is one, print it with a colon */
		if ((t=(Ptr)get_offset_label_str(label_list,instruction-code,true,_module_code_type))!=NULL
				&& (line_offset=*(UInt8*)t-5)>0)
		{
			if (((UInt8*)t)[6]==(UInt8)'') /* segment relocation */
			{
				if (!make_segment_relocation_strings(code,instruction,7+t,--line_offset,
						128+temporary,384+temporary,ubasechars))
					operand_labels = false;
				/*++t, --line_offset; // dont print the '' */
			} else
			{
				fwrite(6+t,1,line_offset,stdout);
				fputc(':',stdout);
				if (line_offset>6)
					fputc('\n',stdout); /* label too long; carry to next line */
				else if (line_offset>2)
					goto ntz;
			}
		}

		if (next_table_size<=0 || (next_table_size&1)!=0)
			if (module_start!=NULL)
				print_local_offset(instruction-module_start);
			else
				fputc('\t',stdout);
	ntz:
		if (next_table_size>0 && (next_table_size&1)==0 && next_table_xsize>0)
		{ /* implementation for 32 bit offsets (far code); 2008.06.18 17:49 GMT */
			long		jmp_rx_offset = instruction-code-2;

			if ((option_flags&_process_cases)
					&& (t=(Ptr)get_offset_label_str(label_list,jmp_rx_offset,false,_module_code_type))!=NULL
					&& (line_offset=*(UInt8*)t-5)>0)
			{ /* case label listing; 2007.12.18 10:52 GMT */
				long		adjustment = *(SInt32*)(2+t), displacement;
				int			line_length, i = 0;

				/* precalculate a starting string (not improved for tab_width!=4) */
				temporary[10+line_offset] = '+';
				*(UInt16*)temporary = '\t\t',
					*(UInt32*)(6+temporary) = '\t\t\t-';
				if (next_table_xsize==4)
					*(UInt32*)(2+temporary) = (option_flags&_force_lowercase) ? 'dc.l':'DC.L';
				else /* added DC.L; 2008.06.18 22:49:58 GMT */
					*(UInt32*)(2+temporary) = (option_flags&_force_lowercase) ? 'dc.w':'DC.W';
				memcpy(10+temporary,6+t,line_offset);
				line_offset += 11;

				do
				{
					if (next_table_xsize==4)
						displacement = *((SInt32*)instruction)++;
					else
						displacement = *((SInt16*)instruction)++;
					if ((t=(Ptr)get_offset_label_str(label_list,displacement+jmp_rx_offset,
							false,_module_code_type))==NULL || (line_length=*(UInt8*)t-5)<=0)
						{printf("%.10s$%04X\n", temporary,displacement&=0xFFFF); continue;}
					/*fwrite(temporary,1,line_offset,stdout);
					fputc('-',stdout);
					fwrite(6+t,1,name_length,stdout);*/

					memcpy(line_offset+temporary,6+t,line_length);

					line_length += line_offset;
					if ((displacement+=adjustment-*(SInt32*)(2+t))!=0)
					{
						if (displacement>0)
							temporary[line_length] = '+';
						else
							temporary[line_length] = '-', displacement = -displacement;
						temporary[++line_length] = '$';
						line_length += make_base_string((++line_length)+temporary,ubasechars,displacement,16,0);
					}

					temporary[line_length] = '\n';
					if (i++==0) /* skip first tab */
						fwrite(1+temporary,1,line_length,stdout);
					else
						fwrite(temporary,1,++line_length,stdout);
				} while((next_table_size-=next_table_xsize)!=0);
				bytes_used = 0;
			} else
			{
				/*fputc('\n',stdout);*/
				/* as 32 bit (respectively); 2008.06.18 19:00:20 GMT */
				if (next_table_xsize==4)
					print_32_bit_offsets(instruction,code_term,module_start,next_table_size,0,
						(option_flags&_force_lowercase)==0,false);
				else
					print_trailer(instruction,code_term,module_start,next_table_size,0,
						(option_flags&_force_lowercase)==0,false);
				if (user_abort)
					return;
				bytes_used = next_table_size;
			}
			fputc('\n',stdout);
			previous_instruction2 = previous_instruction = NULL, next_table_size = -1;
			continue;
		}

		/* modify operands for address refs (no traps or DC.x this time) */
		if ((label_list!=NULL || (option_flags&_no_negative_absolutes))
				&& temporary[1]!='_' && temporary[0]>2 && temporary[128]>0
				&& *(UInt16*)(1+temporary)!='DC' && *(UInt16*)(1+temporary)!='dc'
				&& operand_labels)
			insert_operand_labels(label_list,ubasechars,(option_flags&_coderef_modules) ?
				temporary:NULL,128+temporary,384+temporary,code_id,option_flags&_no_negative_absolutes);

		fputc('\t',stdout);

		/* relocatable data refs on LEA line may remove destination; 2008.06.19 00:51 GMT */
		if ((*(UInt16*)instruction&0xF1C0)==0x41C0 && ((UInt8*)instruction)[1]>0xE7
				&& temporary[128+temporary[128]]==')' && temporary[128]<=252)
		{
			*(UInt16*)(temporary[128]+129+temporary) = (option_flags&_force_lowercase)==0 ? ',A':',a';
			temporary[128+(temporary[128]+=3)] = '0'-(0x41>>1)+(*(UInt8*)instruction>>1);
		}

		/* tabs look better (and they take up less space); 2007.12.05 04:14 GMT */
		//printf("\t\t%-16P%-24P", temporary,128+temporary);
		if ((line_offset=(tab_width*5-1-(signed)fwrite(1+temporary,1,temporary[0],stdout))/tab_width)>32)
			line_offset = 32; /* practical limit */
		if ((UInt8)(temporary[128]|temporary[384])!=0)
		{ /* try to fix this superfluous crap; 2008.05.30 14:09 GMT */
			int		old_offset = line_offset<0 ? line_offset:0;

			if (line_offset>0)
				do{fputc('\t',stdout);} while(--line_offset!=0);
			else if (temporary[128]!=0 && temporary[129]!=';')
				fputc(' ',stdout), line_offset = -1; /* minimal seperation for overflow */

			if ((line_offset+=(old_offset+tab_width*8-1-(signed)fwrite(129+temporary,1,temporary[128],stdout))/tab_width)>32)
				line_offset = 32; /* practical limit */
			if (temporary[384]!=0 && (option_flags&_no_on_line_comments)==0)
			{
				if (line_offset>0)
					do{fputc('\t',stdout);} while(--line_offset!=0);
				/* okay for no seperation (comment string starts with a semi-colon) */

				fwrite(385+temporary,temporary[384],1,stdout);
			}
		}
		fputc('\n',stdout);
	jmp_rx:
		if (bytes_used+instruction==(Ptr)next_module)
			goto next;
		if ((unsigned)((opword_x=*(UInt16*)instruction)-0x4E74)<=1)
			++module_return_count;
		/* if we are coming after a JMP or RTS, print the following offset anyway
			(for convenience); 2007.12.14 00:39 GMT */
		next_table_xsize = 0;
		if (opword_x==0x4E75 || (opword_x&0xFFC0)==0x4EC0)
		{ /* implementation for "far code", 32 bit offsets; 2008.06.18 17:51:15 GMT */
			if ((*(UInt32*)instruction&0xFFFF07FF)==0x4EFB0000 && previous_instruction!=NULL
					&& (*(UInt32*)previous_instruction&0xE1FF07FF)==0x203B0006
					&& last_compare!=NULL) /* check for ADD removed; 2008.06.18 19:34:31 GMT */
					/*&& ((opword_x=*(UInt16*)(t=previous_instruction-2)&0xF1F8)==0xD080
					|| opword_x==0xD040)) // ADD.L|ADD.W */
			{ /* near switch using 'JMP *+xx(Dx.x)' and table; 2007.12.16 05:38 GMT */
				UInt8		reg_ix = ((UInt8*)instruction)[2]>>4;

				/* following the instructions backward, find the range of the table
				if (((opword_x=((UInt16*)t)[-1])&0xF000)!=0x6000) // Bcc.W
					t += 2; // (probably) Bcc.S */
				if (((opword_x=*(UInt16*)last_compare)&0xF800)==0x7000) /* MOVEQ */
					next_table_size = (SInt8)opword_x;
				else if ((opword_x&0xF8FF)==0x203C)
					next_table_size = *(SInt32*)(2+last_compare);
				else if ((opword_x&0xFFF0)==0x0C40) /* CMPI.W */
					next_table_size = *(SInt16*)(2+last_compare);
				else if ((opword_x&0xFFF0)==0x0C80) /* CMPI.L */
					next_table_size = *(SInt32*)(2+last_compare);

				/* using MOVE-Ix instead of ADD for check; 2008.06.18 19:51:08 GMT */
				if (next_table_size>=0 && (*(UInt8*)previous_instruction&15)==reg_ix)
				{ /* update for entry size (xsize); 2008.06.18 18:52 GMT */
					next_table_xsize = *(UInt8*)previous_instruction==0x20 ? 4:2;
					next_table_size = next_table_xsize*(1+(unsigned)next_table_size);
					if (option_flags&_process_cases)
						goto next; /* let the label speak for itself */
				}
			}

			if (function>=0)
				goto print_offset;
		} else if (((opword_x=*(UInt16*)instruction)&0xF1FF)==0x203C /* MOVE.L -- fix; 2008.06.18 18:40 GMT */
				|| (opword_x&0xF100)==0x7000 /* MOVEQ -- fix; 2008.08.25 04:32 GMT */
				|| (opword_x&0xFF38)==0x0C00) /* CMPI.x #,Dx (maybe) -- fix; 2008.06.18 18:18 GMT */
			last_compare = instruction;
		else if (module_start==NULL && (*(UInt8*)instruction&0xF0)==0x60
				&& function>=0) /* offset printed for all branches; 2008.04.15 20:54 GMT */
		{
		print_offset:
			if (option_flags&_avoid_nested_comments)
				fputc('\n',stdout); /* empty line for option; 2008.06.20 01:20 GMT */
			else
				fprintf(stdout,"; %08X\n", bytes_used+instruction-code);
		}
	next:
		previous_instruction2 = previous_instruction;
		previous_instruction = instruction;/*, next_table_size = -1;*/
	} while((instruction+=bytes_used)<first_end);

	if (function<0)
		return;
	if (function>0)
		goto creloc;/*dreloc*/
	if (instruction<first_end)
	{
		print_trailer(instruction,first_end,module_start,1L<<24,instruction-code,
			(option_flags&_force_lowercase)==0,true);
		if (user_abort)
			return;
	}

dreloc:
	if (data_reloc>0 && (size=(code_reloc<termination && data_reloc<code_reloc ?
			code_reloc:termination)-data_reloc)>0)
	{
		if (function==0)
			puts("; Data relocation Table:");
		/* data references in dump; 2008.06.19 00:24 GMT */
		print_compressed_offsets(data_reloc+(UInt8*)code,size,function==0 ? NULL:"drel%u: %08X\n");
		if (user_abort)
			return;
	}
creloc:
	if (code_reloc>0 && (size=(data_reloc<termination && code_reloc<data_reloc ?
			data_reloc:termination)-code_reloc)>0)
	{
		if (function==0)
			puts("; Code relocation Table:");
		else
			fputc('\n',stdout);
		print_compressed_offsets(code_reloc+(UInt8*)code,size,function==0 ? NULL:"srel%u: %08X\n");
	}

	if ((unsigned)termination>1)
		fputc('\n',stdout);
}

/* this only recognizes two forms! */
static SInt32 *build_uniform_jumptable(SInt32 *jt, int count, int version)
{
	SInt32			*data = jt, *allocation, *table, length;

	/* fputs to stderr instead of puts; 2008.06.18 18:07:58 GMT */
	if ((length=(unsigned)count<<3)<=0)
		{fputs("### build_uniform_jumptable: bad count!",stderr); return NULL;}
	if (version<0)
		length += 16; /* re-adjustment for physical offset (its still placed the same) */

	/* always 8 bytes/entry; subtract 0x22 or 0x32 from A5 displacements to get offset */
	if ((allocation=(SInt32*)NewPtr(length))==NULL)
		{fputs("### build_uniform_jumptable: out of memory",stderr); return NULL;}

	table = allocation;
	data += 4; /* skip header */
	if (version<0)
	{ /* assuming this is the extended format, the first CODE (for 32-bit patches) is skipped */
		data += 4; /* skip seg-loader patch (supposed to be called only once) */
		/* instead, fill (mostly) with one bits (user code should not be calling patcher); 2007.12.13 23:51 GMT */
		*table++ = INT_UNDEF, *table++ = -1, *table++ = INT_UNDEF, *table++ = -1;
		do
		{
			*table++ = *((SInt16*)data)++; /* segment ID (xxxx) */
			if (*((UInt16*)data)++!=0xA9F0) /* _LoadSeg */
				goto bad;
			*table++ = *data++; /* segment offset (xxxxxxxx) */
		} while(--count!=0);
	} else
		do
		{
			if ((table[1]=*((SInt16*)data)++)<0 /* segment offset (xxxx) */
					|| *((UInt16*)data)++!=0x3F3C) /* MOVE.W #xxxx,-(A7) */
				goto bad;
			*table++ = *((SInt16*)data)++; /* segment ID */
			if (*((UInt16*)data)++!=0xA9F0) /* _LoadSeg */
				goto bad;
			(*table++) += 4; /* near references are offset by four bytes */
		} while(--count!=0);

	return allocation;
bad:
	DisposePtr((Ptr)allocation);
	printf("### Jump Table is bad or unrecognizable; Offset: %08X", -2+(Ptr)data-(Ptr)jt);

	return NULL;
}

static Str255		resource_name_match = "\p";

static Ptr load_code_resource(short target_rf, short code_id, long *out_size)
{
	Handle			h;
	Ptr				data = NULL;
	OSType			type;
	long			size = -1;
	OSErr			err = noErr;
	short			old_rf = CurResFile();

	UseResFile(target_rf);
	SetResLoad(0);
	h = Get1Resource(code_type,code_id);
	SetResLoad(1);
	UseResFile(old_rf);

	if (h==NULL)
		return NULL;
	fflush(stdout); /* in case of error */
	if ((unsigned)((size=GetResourceSizeOnDisk(h))-16)>(8<<20))
		{fprintf(stderr,"### %-4.4s ID #%d is empty or resource is bad (%d).\n", &code_type,code_id,size); goto end;}

	if ((data=NewPtr(size>256 ? size:256))==NULL)
		{fprintf(stderr,"### No memory for %-4.4s ID #%d (%d).\n", &code_type,MemError()); goto end;}
	GetResInfo(h,&code_id,&type,(UInt8*)data);

	/* dont pass resources without chosen name (unless its CODE ID 0) */
	if ((err=ResError())==noErr && (code_type!=FOUR_CHAR_CODE('CODE') || code_id!=0)
			&& resource_name_match[0]!=0 && IUCompString(resource_name_match,(UInt8*)data)!=0)
		err = userCanceledErr;

	if (err==noErr)
	{ /* in decimal and hexadecimal (also adding # to others); 2008.04.15 20:24 GMT */
		/* remove nulls and line endings from name (to make it entirely printable) */
		UInt8		*s = (UInt8*)data, c, x;

		if ((x=*s++)!=0)
			do
			{
				if ((c=*s++)==0 || c==127)
					s[-1] = '.';
				else if ((c+=-'\n')==0 || (c+='\n'-'\r')==0)
					s[-1] = '';
			} while(--x!=0);
		printf("; %-4.4s ID #%d %P\n; Size: %06X (#%u)\n", &code_type,code_id,data,size,size);
		ReadPartialResource(h,0,data,size);
		err = ResError();
	}
	fflush(stdout);
	if (err!=noErr && err!=userCanceledErr)
		{fprintf(stderr,"### Error (%d) loading CODE ID #%d\n", &code_type,err,code_id); goto end;}
end:
	/* -- dont release; not allocated, and may be accessed again */
	/* leave resource release up to CloseResFile */

	if (err!=noErr && data!=NULL)
		{DisposePtr(data); data = NULL;}
	if (out_size!=NULL)
		*out_size = size;

	return data;
}

static int get_code_resource_index_id(short target_rf, int x)
{
	Handle			h;
	short			old_rf = CurResFile(), result_id;

	UseResFile(target_rf);
	SetResLoad(0);
	h = Get1IndResource(code_type,x+1);
	SetResLoad(1);
	UseResFile(old_rf);

	if (h==NULL)
		return INT_UNDEF;

	GetResInfo(h,&result_id,(OSType*)(256+temporary),temporary);
	if (resource_name_match[0]!=0 && IUCompString(temporary,resource_name_match)!=0)
		return INT_UNDEF+1;

	return result_id;
}

static int get_code_resource_count(short target_rf)
{
	int				count;
	short			old_rf = CurResFile();

	UseResFile(target_rf);
	count = Count1Resources(code_type);
	UseResFile(old_rf);

	return count;
}

static void do_that_thing(short target_rf, /* target ResFile */
	int only_id, /* only jump table entries with this code_type resource ID */
	long starting, /* (optional) starting offset into resource */
	long terminating, /* (optional) terminating offset into resource */
	const char *only_module, /* disregard modules without this name */
	UInt32 option_flags,
	Boolean verbose,
	int function, /* 1: print destination offsets only */
	UInt8 *label_list) /* zero-length-terminated strlist */
{
	SInt32			*jt_data = NULL;
	Ptr				data;
	long			resource_size = -1;
	int				version = 0, jt_length = 0, jt_count = -1, code_id = 0, x = 0;

	if (verbose)
		printf(
"#  target RF: %d, resource type '%-4.4s' (0x%08X)\n"
"#  target resource ID %d\n"
"#  target resource name: %c%P%c\n"
"#  target code range [%d,%d]\n"
"#  target module name: %c%s%c\n"
"#  force lowercase: %c\n"
"#  use coderef names: %c\n"
"#  process cases: %c\n"
"#  use coderef modules: %c\n"
"#  offsets into module: %c\n"
"#  function: %d\n"
"#  loaded label count: %u\n"
			,target_rf,&code_type,code_type,only_id,resource_name_match[0]==0 ? '<':'',
			resource_name_match[0]==0 ? "\pnone":resource_name_match,
			resource_name_match[0]==0 ? '>':'',starting,terminating,only_module==NULL ?
			'<':'',only_module==NULL ? "none":only_module,only_module==NULL ? '>':'',
			(option_flags&_force_lowercase) ? 'y':'n',
			(option_flags&_coderef_names) ? 'y':'n',
			(option_flags&_process_cases) ? 'y':'n',
			(option_flags&_coderef_modules) ? 'y':'n',
			(option_flags&_module_offsets) ? 'y':'n',function,
			label_list==NULL ? 0:*(UInt32*)label_list);

	read_code_target_rf = target_rf;

	fputc('\n',stdout);
	if ((data=load_code_resource(target_rf,code_id,&resource_size))==NULL)
	{
		if (only_id<0 && resource_size<0 && verbose || code_type==FOUR_CHAR_CODE('CODE'))
			fprintf(stderr,"## No %-4.4s ID %d\n", &code_type,code_id);
		if (jt_count==-1)
			jt_count = get_code_resource_count(target_rf);
		goto start;
	}

	version = ((SInt16*)data)[13];
	jt_data = (SInt32*)data;
	if ((jt_length=jt_data[2])<=7)
		{fprintf(stderr,"### Error: Bad or unusable data size (%d)\n", jt_length); goto end;}
	if (jt_length+16>resource_size)
		{fprintf(stderr,"### Error: Jump table data size (%d) > resource size (%d)\n", jt_length+16,resource_size); goto end;}

	if (function==0 && (option_flags&_print_headings))
		printf(
"; JT Header\n"
";\tAbove A5:\t%08X\n"
";\tBelow A5:\t%08X\n"
";\tVersion:\t%04X\n"
";\tLength:\t\t%08X\n"
";\tOffset:\t\t%08X\n\n",
			jt_data[0],jt_data[1],version>0 ? 0:version&0xFFFF,jt_length,jt_data[3]);

	fflush(stdout);

	/*jt_length -= 16;*/
	if ((jt_data=build_uniform_jumptable(jt_data,jt_count=jt_length-(version<0 ? 16:0)>>3,version))==NULL)
		goto end;
	DisposePtr(data); data = NULL;
start:
	if (version<0) /* adjust (again) to make up for far model; 2008.06.18 18:21:11 GMT */
		x += 2, jt_count += 2;
	do
	{
		long		version_or_offset, check;
		long		offset = starting, finalize = terminating;
		long		data_reloc_address = 0, code_reloc_address = 0;
		SInt32		*head;

		global_idle_proc();
		if (user_abort)
			break;

		if (jt_data!=NULL)
		{ /* silence the segment ID (disassemble it once); done with merely negation */
			if (x>0 && code_id>0)
			{
				SInt32		*s = x*2+jt_data, i = jt_count-x, v = -code_id, t = 0;

				do
				{
					if (*s==code_id)
						*s = v, ++t;
					s += 2;
				} while(--i!=0);

				if (verbose && t!=0)
					printf("# %u other instances of ID %d skipped\n", t,code_id);
			}
			code_id = jt_data[x*2];
			if (verbose && code_id>0)
				printf("# Pulled ID %d from jump table\n", code_id);
		} else if (only_id<0)
			if ((code_id=get_code_resource_index_id(target_rf,x))==INT_UNDEF)
			{
				if (code_id==INT_UNDEF+1)
					continue;
				break;
			}

		/* choosing segment #0 may give unpredictable results... */
		if (code_id<0 || only_id>=0 && code_id!=only_id
				|| (data=load_code_resource(target_rf,code_id,&resource_size))==NULL)
			goto next;
		head = (SInt32*)data;

		/* the JT version doesnt seem to matter with this heading */
		if (code_type==FOUR_CHAR_CODE('CODE'))
		{
			version_or_offset = *((SInt16*)head)++, check = *((SInt16*)head)++;
			if (function!=0 || (option_flags&_print_headings)==0)
			{
				if (check==0 && version_or_offset==-1)
				{
					data_reloc_address = head[4], code_reloc_address = head[6];
					head += 9;
				}
			} else if (check==0 && version_or_offset==-1)
			{
				printf(
"; Format ID:\t\t%04X\n"
"; (32 bit)\t\t\t%04X\n",
					version_or_offset&0xFFFF,check&0xFFFF);
				printf(
"; Near Offset:\t\t%08X\n",
					*head++);
				printf(
"; Near Count:\t\t%08X\n",
					*head++);
				printf(
"; Far Offset:\t\t%08X\n",
					*head++);
				printf(
"; Far Count:\t\t%08X\n",
					*head++);
				data_reloc_address = *head++;
				printf(
"; Code Reloc Addr:\t%08X\n"
"; Code Placeholder:\t%08X\n",
					data_reloc_address,*head++);
				code_reloc_address = *head++;
				printf(
"; Data Reloc:\t\t%08X\n"
"; Data Placeholder:\t%08X\n",
					code_reloc_address,*head++);
				printf(
"; (Reserved):\t\t%08X\n",
					*head++);
			} else
				printf(
"; JT Offset:\t\t%04X\n"
"; Entry Count:\t\t%04X\n",
					version_or_offset,check);
		}

		if ((unsigned)offset>resource_size)
			offset = (Ptr)head-data;
		if ((unsigned)finalize>resource_size)
			finalize = resource_size;
		if (function==1)
		{ /* if we are to dump labels for modules, then we should prescan so module
		   names always show up (versus module labels coming first) */

			puts("\n# HDL; - label dump marker");
			puts("\n; modules");
			do_code(data,offset,resource_size,finalize,data_reloc_address,code_reloc_address,code_id,
				jt_data,jt_count,only_module,option_flags,-1,NULL);
			puts("\n; labels/coderefs");
		}

		do_code(data,offset,resource_size,finalize,data_reloc_address,code_reloc_address,code_id,
			jt_data,jt_count,only_module,option_flags,function,label_list);
		/* store offsets only apply locally */
		if (stored_offsets!=NULL)
			{DisposeHandle((Handle)stored_offsets); stored_offsets = NULL;}
		if (stored_offset_count>0)
			stored_offset_count = 0;
		if (user_abort)
			break;
	next:
		if (data!=NULL)
			{DisposePtr((Ptr)data); data = NULL;}
		if (stored_offset_count<0)
			break; /* indicates an error occured during addition of an offset */
	} while(++x<jt_count);
end:
	if (data!=NULL)
		DisposePtr(data);
	if (jt_data!=NULL)
		DisposePtr((Ptr)jt_data);

	/* unload temporary crap */
	read_code_target_rf = -1;
	if (temp_code_read_buffer!=NULL)
		{DisposePtr(temp_code_read_buffer); temp_code_read_buffer = NULL;}

	return;
}

/* \312 is the double-space char */
#define skip_whitespace(s,e)				do{do{if(s>=e||(c=*s++)==0||(c+=-'\n')==0 \
	||(c+='\n'-'\r')==0) goto next;} while((c+='\r')<=' '||(c+=-'\312')==0); --s;}while(0)

/*
	;		label/internal offset
	:		module/external offset
			branch island
			data relocation (user generated); '' ignored
			code relocation (assumed instruction offset); name ignored
*/
static UInt8 *make_label_list(FILE *stream)
{ /* buf needs enough for the complete name, whitespace and guiding symbols
		-- a line will only be read once! */
	char			buf[384];
	/* parsed string pointer, allocated data, temporary pointer, end of string buffer */
	char			*s, *l = NULL, *t = NULL, *e = sizeof(buf)-1+buf;
	long			a = 4, i; /* allocated total, temporary */
	UInt32			n = 0; /* total count */
	Boolean			g = false; /* has dump marker */

	while(fgets(s=buf,sizeof(buf),stream))
	{
		/* remaining, parsed offset, post-name offset, pre-name heading, data size */
		long		x, o, f = -2, h = 0, z;
		UInt8		c = 0, y; /* parsed char, type */
		Boolean		r = false; /* has name */

		if ((x=strlen(s))<=0)
			continue;
		do
		{
			if ((c=*s++)==0 || (c+=-'\n')==0 || (c+='\n'-'\r')==0)
					/*|| (c+='\r'-'\f')==0)*/
				break;
			if ((c+='\r'-'\t')==0 || (c+='\t'-'\312')==0 || (c+='\312'-' ')==0)
			{
				if (f<0)
					if (f==-2) /* still at beginning of line (tabulation) */
						h = s-buf;
					else
						f = s-buf-1;
				continue;
			}
			if ((c+=' '-';')==0 || (c+=';'-':')==0)
			{ /* label/coderef or module (if line starts with name) */
				if (!r || !g)
					break;
				y = s[-1]==':' ? _module_heading_type:_module_boffset_type;
				if (f<0)
					f = s-buf-1; /* -1 because we read past the listed char */
				skip_whitespace(s,e);

				i = strlen(s);
				/* exclude line ending in length */
				if ((c=s[i-1]-'\n')==0 || (c+='\n'-'\r')==0)
					--i;

				/* calculate offset parameter */
				if (i<=8) /* 8 chars hex, (semi-)colon and at least one space/tab */
				{
					if (x<=7)
						break; /* too short (must be 8 hex digits) */
					*--s = 'x', *--s = '0'; /* crude */
					o = read_any_integer(s);

					if (buf[h]=='')
						y = _module_dataref_type, ++h;
				} else
				{ /* (fake) offset is a crc checksum (forced negative) */
					o = (long)0x80000000|~calculate_crc32(s,i,-1);
					y = _module_coderef_type;
				}

				/* final offset - heading -> name length */
				if ((f-=h)<=0)
					break;

				/* append offset and name */
				/* note that names are clipped to 250 chars in storage, and text
				  is clipped to fit 255 chars on the printed disassembly line */
				if ((z=5+f)>255)
					z = 255;
				/*if (l==NULL)
					a = 2;*/
				if ((t=realloc(l,1+z+a))==NULL)
				{
					fputs("## make_label_list: no memory for addition\n",stderr);
					goto damn;
				}
				l = t;
				l[a] = z, l[1+a] = y;
				*(UInt32*)(2+a+l) = o;
				memcpy(6+a+l,h+buf,f);
				a += ++z;
				if (n++>=MAXIMUM_NUMBER_OF_LABELS) /* ++n-1>= so overflow works out */
				{
					fputs("## make_label_list: too many labels!\n",stderr);
				damn:
					free(l);
					return NULL;
				}
			next:
				break;
			} else if ((c+=':'-'#')==0)
			{ /* MPW comment */
				if (g) /* already have signature - fixed placement of conditional; 2008.04.19 20:08 GMT */
					break;
				/* see if we get our label dump signature */
				skip_whitespace(s,e);
				if (*(UInt32*)s=='HDL;') /* good cholesterol */
					g = true;
				break;
			} else
			{
				r = true;
				if (f==-2)
					++f; /* first word only (now) */
			}
		} while(--x!=0);
		/*if (c<' ')
			continue;*/
	}

	if (l!=NULL)
		*(UInt32*)l = n; /* write the count, and were done */

	return (UInt8*)l;
}

/* added; 2008.05.22 03:17 GMT */
static void disassemble_hex(const char *s,
	long offset,
	long finalize,
	const char *only_module,
	UInt32 option_flags,
	Boolean verbose,
	int function,
	UInt8 *label_list)
{
	char			*buf, *d;
	long			length, z;
	unsigned int	v = 0x00F00000;

	if ((z=(length=strlen(s))>>1)<=0)
		return;
	if ((d=buf=malloc(z=(z+29)&~1))==NULL)
		{fputs("### no memory for hex translation",stderr); return;}
	do
	{
		UInt8		c;

		if ((c=-'0'+*s++)==0 && (*s=='x' || *s=='X') && length>1)
			{++s, --length; continue;} /* ignore '0x'; 2008.05.26 06:48 GMT */
		else if (c<=(UInt8)('9'-'0'))
			v = (v<<4)|c;
		else if ((c+='0'-'A')<=(UInt8)('Z'-'A') || (c+='A'-'a')<=(UInt8)('z'-'a'))
			v = (v<<4)|(c+=10);
		else if (v&0x08000000)
			v <<= 4; /* break in mid-byte */
		if (v&(long)0x80000000)
			*d++ = v, v = 0x00FF0000;
	} while(--length!=0);

	if ((length=(d-buf))&1)
		*d++ = 0, ++length; /* align */
	/* add zeros and RTS termination to promote code disassembly (w/o seeing 4E75) */
	/* the largest instruction size (I could find) is 22 bytes in length */
	*((UInt32*)d)++ = *((UInt32*)d)++ = *((UInt32*)d)++ = *((UInt32*)d)++ = 0; /* +16 */
	*((UInt32*)d)++ = *((UInt32*)d)++ = 0, *((UInt16*)d)++ = 0x4E75; /* +30 */

	/* minimize allocated data */
	/*if (length!=z && length>0 && (d=realloc(buf,length))!=NULL)*/
	/*	buf = d, z = length;*/
	z = d-buf;

	if ((unsigned)finalize>length)
		finalize = length;

	if (verbose && (option_flags&_avoid_nested_comments)==0)
		printf("# Disassembling #%u bytes\n", length);

	do_code(buf,offset<0 ? 0:offset,z,finalize,-1,-1,-1,NULL,0,
		only_module,option_flags,function,label_list);

	if (buf!=NULL)
		free(buf);
	if ((option_flags&_avoid_nested_comments)==0)
		puts("; End of Disassembly");
}

/* these macros eliminate usage of strcmp(...)==0 altogether */
#define _sceq(x,s)							(memcmp(x,s,sizeof(s))==0)
#define _sdceq(x,s,d)						(memcmp(x,s,sizeof(s)-d)==0)
#define _soption(x,s)						(memcmp(x,s,(slen=sizeof(s))-1)==0 \
	&& (((const char*)(x))[sizeof(s)-1]=='\0' || ((const char*)(x))[sizeof(s)-1]==','))

void main(int argc, char **argv)
{
	FSSpec			file;

	char			**a = argv, *s = NULL, *only_module = NULL;
	UInt8			*label_list = NULL;
	UInt32			option_flags;
	long			offset = -1, finalize = -1;
	int				c = argc, only_id = -1, function = 0, tab_width, slen;
	OSErr			err;
	short			target_rf = 0, old_rf = CurResFile();
	Boolean			isFolder, hadAlias, leafIsAlias, verbose;

	/* default options */
	option_flags = _print_headings, verbose = false;
	if (get_disasm_extensions_version()<0x12300) /* incompatible extensions version! */
	{
		if (argc>0)
			fprintf(stderr,"### %s - internal error (incompatible ext. version)");
		exit(-1);
	}

#ifdef APPTOOL
	MoreMasters();
	MoreMasters();
	MoreMasters();
# if !TARGET_API_MAC_CARBON
	MaxApplZone();
# endif
#endif
	if (--c<=0)
	{
		if (c==0)
			fprintf(stderr,"### %s - do you really know what youre doin?\n", argv[0]);
		goto headache;
	}

	while(*(s=*++a)=='-')
	{
		++s;
		if (_soption(s,"dumplabels")) /* previously "-destin" */
		{
			function = 1;
			while((s+=slen)[-1]!=0)
				if (_soption(s,"crfnames"))
					option_flags |= _coderef_names;
				else if (_soption(s,"switchcases"))
					option_flags |= _process_cases;
				else
				{
					fprintf(stderr,"### %s - unrecognized dumplabels extension '%s'\n", argv[0],s);
					goto headache;
				}
		} else if (_sceq(s,"dumpmodules"))
			function = -1;
		else if (_sceq(s,"ending"))
		{
			if (--c==0)
				goto missing;
			finalize = ~1&read_any_integer(*++a);
		} else if (_soption(s,"loadlabels"))
		{
			FILE		*labelfile;

			if (--c==0)
				goto missing;
			while((s+=slen)[-1]!=0)
				if (_soption(s,"crfmodules"))
					option_flags |= _coderef_modules;
				else if (_soption(s,"processcases"))
					option_flags |= _process_cases;
				else
				{
					fprintf(stderr,"### %s - unrecognized loadlabels extension '%s'\n", argv[0],s);
					goto headache;
				}
			if ((labelfile=fopen(s=*++a,"r+"))==NULL)
				{fprintf(stderr,"### %s - error (%d) openning '%s'\n", argv[0],errno,s); goto cancel;}
			if (verbose)
				printf("# Parsing '%s'\n", s);
			if ((label_list=make_label_list(labelfile))==NULL)
			{
				fprintf(stderr,"### %s - no labels parsed\n", argv[0]);
				goto cancel;
			}
		} else if (_sceq(s,"lower"))
			option_flags |= _force_lowercase;
		else if (_sceq(s,"module"))
		{
			if (--c==0)
				goto missing;
			only_module = *++a;
		} else if (_sceq(s,"localoffsets"))
			option_flags |= _module_offsets;
		else if (_sceq(s,"noheaders"))
			option_flags &= ~_print_headings;
		else if (_sceq(s,"nnc")) /* was -noc; 2008.06.20 01:03:22 GMT */
			option_flags |= _avoid_nested_comments;
		else if (_sceq(s,"only"))
		{
			if (--c==0)
				goto missing;
			only_id = read_any_integer(*++a);
		} else if (_sceq(s,"resname"))
		{
			if (--c==0)
				goto missing;
			if ((slen=strlen(*++a))>255)
				slen = 255;
			memcpy(1+resource_name_match,*a,resource_name_match[0]=slen);
		} else if (_sceq(s,"restype"))
		{
			if (--c==0)
				goto missing;
			code_type = read_code_type(*++a);
		} else if (_sceq(s,"start") || _sceq(s,"starting"))
		{
			if (--c==0)
				goto missing;
			offset = ~1&read_any_integer(*++a);
		} else if (_sceq(s,"tabwidth"))
		{
			if (--c==0)
				goto missing;
			tab_width = read_any_integer(*++a);
		} else if (s[0]=='v' && (s[1]=='\0' || _sceq(1+s,"erbose")))
			verbose = true;
		else if (s[0]=='d' && s[1]=='r' && s[2]=='\0')
			option_flags |= _no_negative_absolutes;
		else if (s[0]=='n' && s[1]=='c' && s[2]=='\0')
			option_flags |= _no_on_line_comments;
		else if (s[0]=='d' && s[1]=='h' && s[2]=='\0')
		{
			if (--c==0)
			{
			missing:
				fprintf(stderr,"### %s - '%s' needs a parameter\n", argv[0],--s);
				goto headache;
			}
			disassemble_hex(*++a,offset,finalize,only_module,option_flags,
				verbose,function,label_list);
			goto cancel;
		} else if (_sceq(s,"vers") || _sceq(s,"version"))
		{
			int			xv = get_disasm_extensions_version();

			fputs(
"# reveng " VERSION_STR " " GENERATION_STR "\n"
"# project creation date: 2007.12.03 16:42 GMT\n"
"# project revision date: " REVISION_DATE_STR "\n"
				,stderr); /* removed source file line; 2008.05.31 11:29 GMT */
			fprintf(stderr,
"# disasm ext. version:   %X.%04X\n"
"# no. installed rTrS's:  %d (trap selector info)\n"
				, xv>>16,xv&0xFFFF,get_disasm_selector_trap_count());
			exit(0);
		} else
		{
			if (s[0]==0)
				fprintf(stderr,"### %s - input not supported (try -dh)\n", argv[0]);
			else if ((s[0]!='?' && s[0]!='h') || s[1]!=0)
				fprintf(stderr,"### %s - unrecognized option '%s'\n", argv[0],--s);
		headache:
			fprintf(stderr,"### usage: %s [-only <ID>] filepath\n", argv[0]);
			/* finally added option list (deliberately avoided for frivolous legal reasons); 2007.12.11 */
			fputs(
"#\n"
"#-dh xxxx           disassemble hex (only)\n"
"#-dr                probable datarefs are shown as drefxxx if not found\n"
"#-dumplabels        dump labels and modules to stdout (no headers)\n"
"#  [,crfnames]      scan modules for coderef names\n"
"#  [,switchcases]   add unrolled switch cases as labels (SC switches only)\n"
"#-dumpmodules       dump only module refs to stdout (no headers or markers)\n"
"#-ending xxx        end in code at offset xxx\n"
"#-loadlabels xxx    load label list printout in file xxx\n"
"#  [,processcases]  process labels for unrolled switch cases (SC switches)\n"
"#  [,crfmodules]    use coderef names to find modules\n"
"#-localoffsets      print local module offsets for each instruction\n"
"#-lower             print disassembly in lowercase\n"
"#-module xxx        focus on module names matching xxx\n"
"#-only xxx          only resource ID xxx\n"
"#-nc                no printing of on-line comments ('; ...')\n"
"#-nnc               avoid printing of nested comments\n"
"#-noheaders         avoid printing headers\n"
"#-resname xxx       only resources of this name\n"
"#-restype xxx       set resource type (default: 'CODE')\n"
"#-start[ing] xxx    start in code at offset xxx\n"
"#-tabwidth xxx      set the number of equivalent spaces per tab (default: 4)\n"
"#-v[erbose]         verbose output\n"
"#-vers[ion]         run version info (only)\n"
"#\n"
				,stderr);
			goto cancel;
		}

		if (--c==0)
			{fprintf(stderr,"### %s - expected file path\n", argv[0]); goto cancel;}
	}

	if ((err=MakeResolvedFSSpec_Long(0x8003,0,s,(UInt8*)temporary,&file,
			&isFolder,&hadAlias,&leafIsAlias))!=noErr) /* local directory */
		{fprintf(stderr,"### %s - error (%d) accessing '%s'\n", argv[0],err,s); goto cancel;}
	if (isFolder)
		{fprintf(stderr,"### %s - '%s' is a directory!\n", argv[0],s); goto cancel;}

	if (verbose)
		printf("# Opening resource fork for '%s'\n", s);
	fflush(stdout);
	SetResLoad(0);
	target_rf = FSpOpenResFile(&file,fsRdPerm);
	SetResLoad(1);
	err = ResError();
	UseResFile(old_rf); /* xxxOpenResFile sets target (Apples fault) */
	if (err!=noErr)
	{
		fprintf(stderr,"### %s - error (%d) opening '%s'\n", argv[0],err,s);
		goto cancel;
	}

	do_that_thing(target_rf,only_id,offset,finalize,only_module,option_flags,
		verbose,function,label_list);
cancel:
	if (target_rf>0)
	{
		if (verbose)
			printf("\n# Closing resource fork for '%s'\n", s);
		CloseResFile(target_rf);
	}
	if (label_list!=NULL)
		free(label_list);

	exit(target_rf==-1 ? 1:0); /* was !=-1; 2008.05.22 03:04 GMT*/
}
#endif/*!defined(DISASM_EXTENSIONS)*/
